<?php

class KB_ldap extends KB_class {

	private $lc, $core;

	function __construct ($core) {

		$this->core = $core;
		$this->calc_time = true;
		$this->dev = true;

		$this->time();

		$this->lc = ldap_connect(db_data::$ldap_server);
		ldap_set_option($this->lc, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_bind($this->lc, db_data::$ldap_dn, db_data::$ldap_password);

		$this->time('__contruct');

		$this->group_sync();
	}


	function __destruct() {
  	ldap_close($this->lc);
  }


	public function user_search($id) {

		$this->time();

		$search = ldap_search($this->lc, db_data::$ldap_user_path.",".db_data::$ldap_search_path, db_data::$ldap_user_variable."=".$id);
		$result = ldap_get_entries($this->lc, $search);

		$this->time('user_search');

		return (is_array($result) && array_key_exists(0,$result)) ? $result[0] : false;
	}


	public function user_bind($dn, $password) {
		$this->time();
		$rc = ldap_bind ($this->lc, $dn, $password);
		$this->time('user_bind');
		return $rc;
	}

	public function test_user_data($user, $password) {
		if($userdata = $this->user_search($user)){
			return ($this->user_bind($userdata['dn'], $password)) ? $userdata['uidnumber'][0] : false;
		}
		return false;
	}


	public function group_sync() {
		$this->time();

		$search = ldap_search($this->lc, db_data::$ldap_search_path, "objectclass=".db_data::$ldap_group_objectClass);
		$result = ldap_get_entries($this->lc, $search);

		$this->time('group_sync');

		for($i=0;$i<$result['count'];$i++)
		{
			if(!in_array($result[$i]['gidnumber'][0], db_data::$ldap_group_exclude) && !in_array($result[$i]['cn'][0], db_data::$ldap_group_exclude))
			{
				$gids[] = $result[$i]['gidnumber'][0];
				$sql_add[] = "('".$result[$i]['gidnumber'][0]."','".$result[$i]['cn'][0]."')";
				echo $result[$i]['cn'][0]." - ".$result[$i]['gidnumber'][0]."\n";
			}
		}

		$sql = "DELETE FROM ".DB_PREFIX."kb_user_group WHERE id NOT IN (1,".implode(",",$gids).")";
		$this->db->sql_query($sql);

		$sql = "
			INSERT INTO ".DB_PREFIX."kb_user_group (ID,name)
			VALUES ".implode(",",$sql_add)."
			ON DUPLICATE KEY UPDATE name = VALUES(name)
			";
		$this->db->sql_insert($sql);
	}


	public function showexectime() {
		if($this->calc_time == true && $this->dev == true)
		{
			for($i=0;$i<count($this->time_end);$i++)
			{
				$this->times[1] += $this->time_end[$i][1] - $this->time_start[$i][1];
				$this->times[0] += $this->time_end[$i][0] - $this->time_start[$i][0];
			}
			return ($this->times[0]+$this->times[1]);
		}
	}


	public function showquerytime() {
		if($this->calc_time == true && $this->dev == true)
		{
			$dev = "<div style=\"background:gray;color:white;padding:10px;border:dashed 5px green;margin:5px;\">";
			$dev .= "<table style=\"font-size:10px;\">";
			for($i=0;$i<count($this->time_end);$i++)
			{
				$this->times[1] = $this->time_end[$i][1] - $this->time_start[$i][1];
				$this->times[0] = $this->time_end[$i][0] - $this->time_start[$i][0];
				$dev .= "<tr><td nowrap>No #".$i.": </td><td nowrap>".($this->times[0]+$this->times[1])."</td><td>".$this->queries[$i]."</td></tr>";
			}
			$dev .= "<tr><td nowrap>SUM: </td><td nowrap>".$this->showexectime()."</td><td></td></tr>";
			$dev .= "</table></div>";
			return $dev;
		}
	}


	public function time($stop = false) {
		if($this->calc_time == true)
		{
			if($stop)
			{
				$this->time_end[] =  explode(" ", microtime());
				$this->queries[] = $stop;
			}
			else{$this->time_start[] = explode(" ", microtime());}
		}
	}


	public function set_dev() {
		$this->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$this->dev = true;
		$this->calc_time = true;
	}

}
