<?php
class KB_menu extends KB_class_extended {

	// public $create_submenu = false;

	private $core;

	function __construct($core) {
		$this->config("single_subs",true);
		$this->core = $core;
	}

	// Public


	public function render() {

		$this->create_submenu(false);

		$menu = $this->create(func_get_args());

		if (is_empty($menu))
			return "";

		return $this->core->html->render(
			$this->render_elements($menu)
		);

	}

	// Private

	private function create($args) {

		// Get loaded frontend information

		$contentarray = $this->core->content->frontend->loaded();
		$LIDs_IDs = $this->core->content->group->config("lids_ids");
		$LIDs = $this->core->content->group->config("lids");
		$idofcontent = $this->core->content->frontend->loaded("ID");

		// Should be done in frontend
		// $base_dirs = $this->core->content->group->config("base_dirs");

		$base_dirs = "";


		// Sanitize JSON and comma separated args

		if (
			is_array($args) &&
			not_empty($args) &&
			count($args) === 1 &&
			is_array($json_args = $this->core->json->decode(key_of(0,$args)))
		) {
				$args = $json_args;
			}

		else {

			switch ($type = key_of(0,$args)) {

				case 'main_then_sub':
				case "main":
				case 'sub':
				default:

					$depth = key_of(2,$args);

					if (is_string($depth))
						$depth = trim($depth);

					if (is_numeric($depth))
						$depth = intval($depth);
					else
						$depth = true;

					$args = [
						"structure" => strtolower(trim(either(key_of(1,$args),""))),
						"depth" => $depth,
					];
					break;

				case 'up':
				case 'back':
					$args = [
						"name" => trim(either(key_of(1,$args),"")),
					];
					break;
			}
			$args["type"] = $type;
		}

		// Set default values

		$args = $this->core->array->trim($args);

		$args = $this->core->array->merge([
			"type" => "main",
			"structure" => "NULL",
			"depth" => 0,
			"exclude" => false,
			"filter" => true,
			"separator" => "",
			"submenu" => false,
		],$args);

		$this->config($args);

		switch ($this->structure()) {

			case "current":
				$this->structure(ifttt(
					not_empty($entry = $this->core->content->entry($idofcontent)),
					key_of("group_ID", $entry),
					"NULL"
				));
				break;

			case "parent":
				$this->structure(ifttt(
					(
						not_empty($entry = $this->core->content->entry($idofcontent)) &&
						not_empty($group_entry = $this->core->content->group->entry(key_of("group_ID", $entry)))
					),
					key_of("parent_ID", $group_entry),
					"NULL"
				));
				break;
		}

		if ($this->filter() === false) {
			$this->core->content->group->filter(false);
			$this->core->content->filter(false);
		}

		$menu = [];

		// if (not_empty($kitbooth_url = $this->core->path("url")))
			// $base_dirs = $this->core->folder->path($kitbooth_url, $base_dirs);

		$base_dirs = "/".$base_dirs;

		switch ($this->type()) {

			case 'main_then_sub':

				$this->create_submenu(true);

				$single_subs = $this->config("single_subs");
				$this->config("single_subs", false);
				$menu = $this->create(array("main",key_of("structure", $args),key_of("depth", $args)));
				$this->config("single_subs", $single_subs);

				break;

			case 'main':

				$structures = $this->core->content->group->read_structured($this->structure(),$this->depth());

				if ($this->config("exclude"))
					$structures = $this->core->array->exclude_by($structures, "ID", $this->config("exclude"));

				//Creating main menu

				if (!empty($structures)) {

					$unset_entry = [];

					foreach ($structures as $key => $value) {

						$thiscontent = "";

						// $structure_property = $this->core->content->group->entry($value["ID"]);
						$structure_property = $value;

						switch (key_of("default_content",$structure_property)){
							case "":
								$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID'],"filealias"=>"index.html"));
								if (empty($thiscontent)){
									$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID']));
								}
								break;

							case "index_file":
								$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID'],"filealias"=>"index.html"));
								break;

							case "pos_first":
								$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID']));
								break;

							case "pos_last":
								$thiscontent = $this->core->content->read(array('group_ID'=>$value['ID']));
                $thiscontent = array_slice($thiscontent,-1);
								break;

							case "created_first":
								$this->core->content->order(array("created" => "ASC"));
								$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID']));
								$this->core->content->order(array("created" => ""));
								break;

							case "created_last":
								$this->core->content->order(array("created" => "DESC"));
								$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID']));
								$this->core->content->order(array("created" => ""));
								break;
						}

						if (!empty($thiscontent) && $this->core->content->secured($thiscontent['ID']))	{
							$thiscontent = $this->core->content->entry(array('group_ID'=>$value['ID'],"filealias"=>"401.html"));
							if(!empty($thiscontent) && $this->core->content->secured($thiscontent['ID']))
                $thiscontent = "";
						}

						if (empty($thiscontent)) {
							unset($structures[$key]);
							$unset_entry = $this->core->content->group->read_children($value['ID']);
						}

						else if (in_array($value['ID'], $unset_entry)){
							unset($structures[$key]);
						}

						else {

							$link = $base_dirs.$this->core->folder->path($this->core->structure->structure_ID_to_path($value['ID']));

							$menu[] = array(
							// 'link' 		=> $base_dirs.$this->core->content->group->structure_ID_to_path($value['ID']),
							'link' 		=> $link,
							'name'		=> $value['name'],//$thiscontent['name'];
							'class' 	=> in_array($value['ID'],$LIDs_IDs) ? "mainmenu mainmenu-active" : "mainmenu",
							"depth"		=> $value['depth']
							);


							if ($this->create_submenu()) {

								$new_sub_menu = $this->create(["sub",$value['ID']]);

								if (not_empty($new_sub_menu)) {

									$new_sub_menu = $this->core->array->fill($new_sub_menu, "depth", $value['depth']+1);

									$menu = $this->core->array->concat(
										$menu,
										$new_sub_menu
									);

								}
							}
						}
					}
				}

			break;

			case 'sub':

				$contents = $this->core->content->read(["group_ID"=>$this->structure()]);

				if (is_empty($contents))
					return "";

				if (!$this->config("single_subs") && count($contents) < 2)
					return "";

				foreach ($contents as $key => $value) {

					$thiscontent = $this->core->content->entry($value["ID"]);

					if ($this->core->content->secured($thiscontent['ID']))
						continue;

					$link = $base_dirs.$this->core->folder->path($this->core->structure->structure_ID_to_path($thiscontent['group_ID']));
					// $link = $this->core->folder->path($this->core->structure->structure_ID_to_path($thiscontent['group_ID']));

					if (
						not_empty(
							key_of("default_content",$this->core->structure->entry(key_of("group_ID", $thiscontent)))
						)
						|| !are_equal(
							$thiscontent['position'],
							"1"
						)
					)
					$link = $link.$thiscontent['filealias'];

					$menu[] = array(
						// 'link'	=> $thiscontent['ID'] == $idofcontent  ? '' : ($thiscontent['filealias'] == 'index.html' ? $this->structure->structure_ID_to_path($thiscontent['group_ID']) : $this->structure->structure_ID_to_path($thiscontent['group_ID']).$thiscontent['filealias']),
						// 'link'	=> $base_dirs.($thiscontent['filealias'] == 'index.html' ? $this->core->structure->structure_ID_to_path($thiscontent['group_ID']) : $this->core->structure->structure_ID_to_path($thiscontent['group_ID']).$thiscontent['filealias']),
						'link'	=> $link,
						'name'	=> $thiscontent['name'],
						'class'	=> $thiscontent['ID'] == $idofcontent  ? 'submenu submenu-active' : 'submenu'
					);
				}

				if (!$this->config("single_subs") && count($menu) < 2)
					return "";

				break;

			case 'back':

					if(isset($_SERVER['HTTP_REFERER'])) {$menu[0] = array(
						'link'	=> $_SERVER['HTTP_REFERER'],
						'name'	=> $this->name(),
						'class'	=> 'back-link'
					);}


			break;

			case 'backlink':


			// echo $_SERVER['HTTP_REFERER'];
			/*		if(isset($_SERVER['HTTP_REFERER'])) {$menu[0] = array(
						'link'	=> $_SERVER['HTTP_REFERER'],
						'name'	=> $name,
						'class'	=> 'back-link'
					);}
				*/
			break;

			case 'up':

				$thiscontent = $this->core->content->entry($idofcontent);
				$structure_pos = empty($thiscontent) ? 'NULL' : $thiscontent['group_ID'];
				$this_structure = $this->structure->read_per('ID',$structure_pos,1);

				$structures = $this->structure->read_parents($structure_pos);


				if (!empty($structures)) {

					$structures = array_reverse($structures);

					$structures = $this->structure->read_per(array('ID'=>$structures));

					$menulink = '';
					foreach($structures as $key => $value)
					{
							$backstructure = $this->structure->read_per(array('ID'=>$value['ID']),'',1);
							if(!empty($backstructure) && $backstructure['defaultpath'] == 0)
							{
								$menulink = $backstructure['is_base_dir'] == 0 ? $menulink.$backstructure['url_path_name'].'/' : '/';
							}
							else
							{
								unset($structures[$key]);
							}
					}
					if(empty($structures) && $this_structure['defaultpath'] == 0 && $this_structure['is_base_dir'] == 0) $menulink = '/';
				}
				if(!empty($menulink))
				{
					$menu[0] = array(
						'link'	=> '/'.$menulink,
						'name'	=> $this->name(),
						'class'	=> 'up-link'
					);
				}
				break;

				case 'breadcrumbs':


					// Read current content
					$thiscontent = $this->core->content->entry($idofcontent);

					//Read all structure IDs of current filealias
					$structureIDs = empty($thiscontent) ? [] :  array_merge(array($thiscontent['group_ID']),$this->structure->read_parents($thiscontent['group_ID']));

					//Complete structures with infos
					//Unset structures which are default structures - there's no need to link them
					$structures = [];
					foreach($structureIDs as $key => $value)
					{
						$structure = $this->structure->read_per('ID',$value, 1);
						if(isset($structure['is_base_dir']) && $structure['is_base_dir'] == 1) break;
						if(isset($structure['defaultpath']) && $structure['defaultpath'] == 0)
						{
							$structures[] = $structure;
							$last_structure_ID = $structure['ID'];
						}
					}

					//Find all the structures which are used as root.
					$default_structures = isset($last_structure_ID) ? $this->structure->read_parents($last_structure_ID) :  $structureIDs;

					//If exists, unset root structure
					foreach($default_structures as $key => $value)
					{
						if($value == 'NULL') unset($default_structures[$key]);
					}

					//Read informations about the index file placed in the root structure
					$rootcontent = $this->core->content->search_content('index.html',count($default_structures));

					//Build up all links
					while(!empty($structures))
					{
						$link = "";
						$structure = current($structures);
						foreach($structures as $value)
						{
							 $link = $value['url_path_name'].'/'.$link;
						}
						$link = '/'.$link;

						//$name = $this->core->content->read_per(array('filealias'=>'index.html','structure_ID'=>$structure['ID']));

						//if(!empty($name)) $name = empty($name[0]['meta_title']) ? $name[0]['name'] : $name[0]['meta_title'];

						$menu[count($menu)] = array(
									'link'	=> $thiscontent['group_ID'] == $structure['ID'] && $thiscontent['filealias'] == 'index.html' ? '' : $link,
									'name'	=> $structure['name'],
									'class'	=> $thiscontent['group_ID'] == $structure['ID'] && $thiscontent['filealias'] == 'index.html' ? 'breadcrumbs active-crumb' : 'breadcrumbs crumb'
						);
						$menu[count($menu)] = array(
									'link'	=> $thiscontent['group_ID'] == $structure['ID'] && $thiscontent['filealias'] == 'index.html' ? '' : $link,
									// 'name'	=> $this->separator,
									'class'	=> $thiscontent['group_ID'] == $structure['ID'] && $thiscontent['filealias'] == 'index.html' ? 'breadcrumbs active-separator' : 'breadcrumbs separator'
						);
						array_shift($structures);
					}

					if(!empty($rootcontent))
					{

						$menu[count($menu)] = array(
									'link'	=> $rootcontent['ID'] == $idofcontent ? '' : '/',
									'name'	=> $rootcontent['name'],
									'class'	=> $rootcontent['ID'] == $idofcontent ? 'breadcrumbs active-crumb' : 'breadcrumbs crumb'
						);
					}
					$menu = array_reverse($menu);
					break;

				case "nextpage":
					$args = string_to_array(implode(",",$args));


					$title	= isset($this->title)	? $this->title	: false;
					$text	= isset($this->text)	? $this->text	: false;
					$loop	= isset($args['loop'])	&&
							  $args['loop'] == true	? true	: false;

					$nextcontent = $this->core->content->read_next_position_elements($contentarray['position'],array('group_ID'=>$contentarray['group_ID']));

					if(!empty($nextcontent)){
						foreach($nextcontent as $key => $value){
							if(!$this->core->content->secured($value['ID'])){
								$nextcontent = $nextcontent[$key];
								break;
							}
						}
					}

					if($loop && empty($nextcontent)){
						$nextcontent = $this->core->content->entry(array('group_ID'=>$contentarray['group_ID'],'position'=>'1'));
					}

					if(!empty($nextcontent)){
						$name = empty($nextcontent['meta_title']) ? $nextcontent['name'] :$nextcontent['meta_title'];
						$menu[] = array(
										'link'	=> $nextcontent['filealias'] == 'index.html' ? $this->structure->structure_ID_to_path($contentarray['group_ID']) : $this->structure->structure_ID_to_path($contentarray['group_ID']).$nextcontent['filealias'],
										'name'	=> $text ? $text : $name,
										'class'	=> 'nextpage',
										'title'	=> $title ? $title : $name,
							);
					}
					break;

				case "prevpage":

					$args = string_to_array(implode(",",$args));


					$title	= isset($this->title)	? $this->title	: false;
					$text	= isset($this->text)	? $this->text	: false;
					$loop	= isset($args['loop'])	&&
							  $args['loop'] == true	? true	: false;

					$prevcontent = $this->core->content->read_prev_position_elements($contentarray['position'],array('group_ID'=>$contentarray['group_ID']));

					if(!empty($prevcontent)){
						foreach($prevcontent as $key => $value){
							if(!$this->core->content->secured($value['ID'])){
								$prevcontent = $prevcontent[$key];
								break;
							}
						}
					}

					if($loop && empty($prevcontent)){
						$prevcontent = $this->core->content->read_last_position_element(array('group_ID'=>$contentarray['group_ID']));
					}

					if(!empty($prevcontent)){
						$name = empty($prevcontent['meta_title']) ? $prevcontent['name'] :$prevcontent['meta_title'];
						$menu[] = array(
										'link'	=> $prevcontent['filealias'] == 'index.html' ? $this->structure->structure_ID_to_path($contentarray['group_ID']) : $this->structure->structure_ID_to_path($contentarray['group_ID']).$prevcontent['filealias'],
										'name'	=> $text ? $text : $name,
										'class'	=> 'prevpage',
										'title'	=> $title ? $title : $name,
							);
					}
					break;
		}
		return $menu;
	}

	private function render_elements($menu = [], $entry_key = 0, $depth_given = 0, $i = 1) {

		if (any_empty($menu, $entry_key))
			return "";


		$depth = false;
		$return = [];
		$sub_menu = false;
		$main_menu = false;
		$main_in_sub = false;

		$menu = array_slice($menu, $entry_key);

		foreach ($menu as $key => $entry) {

			// if ($key < $entry_key)
			// 	continue;

			if ($depth === false) {

				$depth = key_of("depth", $entry);
				$class = key_of("class", $entry);

				// if (are_equal($class, "mainmenu"))
					// $main_menu = true;

				// else
					// $sub_menu = true;

			}

			// if ($main_menu && !are_equal($depth, key_of("depth", $entry)))
			if (!are_equal($depth, key_of("depth", $entry))) {

				if (intval($depth) < intval(key_of("depth", $entry))) {
					continue;
				}
				break;


			}

			// if ($sub_menu && !is_numeric($main_in_sub) && !is_null(key_of("depth", $entry)))
				// $main_in_sub = key_of("depth", $entry);

			// if (is_numeric($main_in_sub) && is_null(key_of("depth", $entry)))
				// break;

			// if (is_numeric($main_in_sub) && !are_equal($main_in_sub, key_of("depth", $entry)))
				// continue;

			// if (is_numeric($main_in_sub) && $main_in_sub < $depth_given)
				// continue;

			$link = $this->core->html->a(
				key_of("name", $entry),
				[
					"href" => key_of("link", $entry),
					"title" => key_of("title", $entry),
					"class" => key_of("class", $entry),
				]
			);

			if (
				not_empty($next_entry = key_of($key+1, $menu)) &&
				!are_equal($next_depth = key_of("depth", $next_entry), $depth) &&
				intval($next_depth) > intval($depth)
			)
				$link = [
					$link,
					// $this->render_elements($menu, $key+1, ifttt($depth, $depth+1, $depth_given+1))
					$this->render_elements($menu, $key+1)
				];

			$container = $this->core->html->span(
				$link,
				[
					"class" => "level".(either($depth, $depth_given)+1)." ".key_of("class", $entry)
				]
			);

			$return[] = $container;

		}

		if (is_empty($return))
			return "";

		$level = either($depth, $depth_given)+1;

		return $this->core->html->span($return, [
			"class" => "level".$level." container level".$level."_container"
		]);

	}


}

