//Zoom5

'use strict';

var Zoom5 = new Object();
Zoom5.current = 0;
Zoom5.opened = false;
var jQuery;

//Init after loaded Dependencies
Zoom5.onload = function()
{
	jQuery(document).ready(function(){

		var TO = false;
		jQuery(window).resize(function(){
			if(TO !== false)
			clearTimeout(TO);
			TO = setTimeout(Zoom5.resize, 100);
		});

		ready('a.zoom', function(element) {
			Zoom5.object(jQuery(this));
		});

		Zoom5.parse();

	});
}

//Load Dependencies
Zoom5.load = function()
{
	if (typeof(jQuery) == 'undefined')
	{
		Zoom5.getScript('//code.jquery.com/jquery-3.3.1.min.js', function() {
		// Zoom5.getScript('//code.jquery.com/jquery-1.11.0.min.js', function() {
			Zoom5.load();
		});

		return false;

	}
	else
	{
		Zoom5.onload();
	}
}

Zoom5.getScript = function (url, success)
{
	var script     = document.createElement('script');
	script.src = url;
	var head = document.getElementsByTagName('head')[0],
	done = false;

	// Attach handlers for all browsers
	script.onload = script.onreadystatechange = function() {

		if (!done && (!this.readyState || this.readyState == 'loaded' || this.readyState == 'complete')) {

		done = true;
		// callback function provided as param
		success();
		script.onload = script.onreadystatechange = null;
		head.removeChild(script);

		};
	};
	head.appendChild(script);
};

Zoom5.parse = function(){

	//switch case

	//enlarge images in container

	jQuery(".zoom").not("a, img").find("img:not(a img)").click(function(event){
		event.preventDefault();
		Zoom5.objects($(this), ".zoom");

	});

	//enlarge images in container
	//enlarge images in links

	jQuery("img.zoom, a.zoom").each(function(){
		Zoom5.object($(this));
	});


	jQuery(".zoom").not("a").find("a").not("[target]").click(function(event){
		event.preventDefault();
		Zoom5.objects($(this), ".zoom");

	});

}


Zoom5.object = function(object = false) {

	if (!object)
		return false;

	object.click(function(event){

		event.preventDefault();
		var objects = new Array();

		if(jQuery(this).attr("href")) {
			objects[0] = jQuery(this);
		}

		else if(jQuery(this).attr("src")) {
			objects[0] = jQuery(this);
			objects[0].attr("href", jQuery(this).attr("src"));
		}

		objects.classes = jQuery(this).attr("class");
		objects.options = jQuery(this).attr("data-zoom5") || "{}";
		objects.options = objects.options.replace(/'/g,"\"");
		objects.options = jQuery.parseJSON(objects.options);
		objects[0].classes = objects.classes;
		objects[0].options = objects.options;


		if(objects.length > 0)
			Zoom5.init(objects,0);

		return false;
	});
}


Zoom5.objects = function(object = false, parent = false) {

	if (!object || !parent)
		return false;

	var objects = new Array();
	var type = jQuery(object).prop('nodeName');
	var src;

	jQuery(object).parents(parent).find(type).each(function(i){

		if (!jQuery(this).attr("href")) {
			if (src = jQuery(this).attr("src")) {
				objects[i] = jQuery(this);
				objects[i].attr("href", src);
			}
			else {
				return;
			}
		}

		objects[i] = jQuery(this);
		objects[i].classes = jQuery(this).attr("class");
		objects[i].options = jQuery(this).attr("data-zoom5") || "{}";
		objects[i].options = objects[i].options.replace(/'/g,"\"");
		objects[i].options = jQuery.parseJSON(objects[i].options);
	});

	objects.classes = jQuery(object).parents(parent).attr("class");
	objects.options = jQuery(object).attr("data-zoom5") || "{}";
	object  = jQuery(object).parents(parent).find(type).index(object);

	if (objects.length > 0)
		Zoom5.init(objects,object);

	return false;

}


Zoom5.init = function(objects,current){
	Zoom5.current = current ? current : 0;
	var object = objects[current];
	Zoom5.open(object,Zoom5.current,objects);
}


Zoom5.open = function (object,current,objects) {

	Zoom5.opened = true;
	var zw_bg = "div.Zoom5";
	var count = objects.length;

	if (jQuery(zw_bg).length == 0) {

		jQuery(document.createElement("div")).addClass("Zoom5").appendTo(jQuery("body")).hide().fadeIn();
		jQuery(document.createElement("div")).addClass("Zoom5_background").appendTo(jQuery("div.Zoom5"));
		jQuery(document.createElement("div")).addClass("Zoom5_content_container").appendTo(jQuery("div.Zoom5 div.Zoom5_background"));
		jQuery(document.createElement("div")).addClass("Zoom5_content").appendTo(jQuery("div.Zoom5 div.Zoom5_content_container"));
		jQuery(document.createElement("div")).addClass("Zoom5_next").appendTo(jQuery("div.Zoom5 div.Zoom5_content_container"));
		jQuery(document.createElement("div")).addClass("Zoom5_prev").appendTo(jQuery("div.Zoom5 div.Zoom5_content_container"));
		jQuery(document.createElement("div")).addClass("Zoom5_close").appendTo(jQuery("div.Zoom5 div.Zoom5_content_container"));
		jQuery(document.createElement("div")).addClass("Zoom5_info").appendTo(jQuery("div.Zoom5 div.Zoom5_content_container"));
		jQuery(document.createElement("div")).addClass("Zoom5_current").appendTo(jQuery("div.Zoom5 div.Zoom5_info"));
		jQuery(document.createElement("div")).addClass("Zoom5_count").appendTo(jQuery("div.Zoom5 div.Zoom5_info"));
		jQuery(document.createElement("div")).addClass("Zoom5_title").appendTo(jQuery("div.Zoom5 div.Zoom5_info"));


		//jQuery("div.Zoom5").click(function(){Zoom5.close()});

	}
	else {
		jQuery("div.Zoom5").fadeIn();
	}

	jQuery(document).off("keydown").keydown(function(event) {
		switch (event.which) {
			case 37: //LEFT
				Zoom5.prev(objects);
				break;
			case 39: //RIGHT
				Zoom5.next(objects);
				break;
			case 27: //ESC
				Zoom5.close();
				break;
		}
	});

	jQuery("div.Zoom5 div.Zoom5_next").off("click").click(function(event){event.stopImmediatePropagation(); Zoom5.next(objects)});
	jQuery("div.Zoom5 div.Zoom5_close").off("click").click(function(){Zoom5.close()});
	jQuery("div.Zoom5 div.Zoom5_prev").off("click").click(function(event){event.stopImmediatePropagation(); Zoom5.prev(objects)});
	jQuery("div.Zoom5 div.Zoom5_content").off("click").click(function(event){event.stopImmediatePropagation()});

	// jQuery("div.Zoom5").removeAttr("class").addClass("Zoom5").addClass(object.classes);
	jQuery("div.Zoom5").addClass(objects.options["class"] || objects.classes).removeClass("zoom");

	Zoom5.content_type(object.attr("href"), function(content_type){

		//jQuery("div.Zoom5 div.Zoom5_content").css("visibility","hidden");

		if (content_type[0] == "image") {
			var new_object = jQuery(document.createElement("img"));
			new_object.attr("src",object.attr("href"));
		}

		else if (content_type[0] == "video") {
			var new_object = jQuery("<video>");
			new_object.attr("src",object.attr("href"));
			new_object.attr("controls","controls");
			new_object.attr("autoplay","autoplay");
			new_object.attr("preload","auto");
			new_object.attr("type","video/"+content_type[1]);
			// source.attr("type","video/"+Zoom5.filetype(object.attr("href")));

		}

		else if (content_type[0] == "html") {

			var new_object = jQuery(document.createElement("iframe"));
			new_object.attr("src",object.attr("href"));
			// new_object.ready(function(){
			// 	jQuery(this).contents().find("head").append('<style>img{max-width:100%}</style>');
			// })
			new_object.attr("style","background:white"); //width:1000px; height: 1000px");
			new_object.attr("height",jQuery("div.Zoom5 div.Zoom5_background").height());
			new_object.attr("width",jQuery("div.Zoom5 div.Zoom5_background").width());

		}

		else{
		}

		if (object.options["element"]) {
			if (object.options["element"]["attr"]) {
				$.each(object.options["element"]["attr"], function(key, value) {
					value = JSON.stringify(value);
					value = value.replace(/"/g,"'");
					new_object.attr(key,value);
				});
			}

		}


		jQuery("div.Zoom5 div.Zoom5_content").empty().prepend(new_object);
		jQuery("div.Zoom5 div.Zoom5_current").html(current+1);
		jQuery("div.Zoom5 div.Zoom5_count").html(count);
		jQuery("div.Zoom5 div.Zoom5_title").html("").html(object.attr("title"));
		jQuery("div.Zoom5.download div.Zoom5_title").append(' <a href="'+object.attr("href")+'" target="_blank" download>Download</a>');

		if (object.options["include"])
			$.each(object.options["include"], function(key, value){
				jQuery("div.Zoom5 div.Zoom5_content").append($(value).clone());
			});


		// new_object.resize();
		// return;

		if (count > 1) {
			jQuery("div.Zoom5 div.Zoom5_current").show();
			jQuery("div.Zoom5 div.Zoom5_count").show();
			jQuery("div.Zoom5 div.Zoom5_prev").show();
			jQuery("div.Zoom5 div.Zoom5_next").show();
		}

		else{
			jQuery("div.Zoom5 div.Zoom5_current").hide();
			jQuery("div.Zoom5 div.Zoom5_count").hide();
			jQuery("div.Zoom5 div.Zoom5_prev").hide();
			jQuery("div.Zoom5 div.Zoom5_next").hide();
		}
	});

	return this;
};


Zoom5.close = function(){
	Zoom5.opened = false;
	jQuery("div.Zoom5").hide();
	jQuery("div.Zoom5 div.Zoom5_content").empty();
};


Zoom5.resize = function() {

	return this;

	//jQuery("div.Zoom5 div.content").css("visibility","hidden");
	var o = jQuery("div.Zoom5 div.Zoom5_content > *");
	var max_size = 0.9;

	//Webkit Bugfix
	if(o.height() == 0 || o.width()  == 0 || o.height() == 150 && o.width() == 300 ) {
		setTimeout(Zoom5.resize,1);
		return this;
	}

	if(o.height() <= 30 || o.width()  <= 30) {
		o.removeAttr("org-height");
		o.removeAttr("org-width");
		setTimeout(Zoom5.resize,1000);
	}

	if(o.attr("org-height")) {
		var o_height = o.attr("org-height");
		var o_width = o.attr("org-width");
	}

	else {
		o.removeAttr("height");
		o.removeAttr("width");
		o.css("height","");
		o.css("width","");
		var o_height = o.height();
		var o_width = o.width();
		o.attr("org-height",o_height);
		o.attr("org-width",o_width);
	}

	o.css("position","absolute");
	var s_height = jQuery("div.Zoom5 div.Zoom5_background").height();
	var s_width = jQuery("div.Zoom5 div.Zoom5_background").width();
	o.css("position","relative");

	var r_height = o_height/s_height;
	var r_width  = o_width/s_width;

	//Upsize
	if (r_height < 1 && r_width < 1) {
		jQuery("div.Zoom5 div.Zoom5_content > *").css("height",Math.floor(o_height)+"px");
		if (jQuery("div.Zoom5 div.Zoom5_content > *").css("width")){
			jQuery("div.Zoom5 div.Zoom5_content > *").css("width",Math.floor(o_width)+"px");
		}
	}

	//Downsize
	if (r_height > max_size || r_width > max_size) {
		var ratio = r_height > r_width ? r_height : r_width;
		jQuery("div.Zoom5 div.Zoom5_content > *").css("height",Math.floor(o_height/ratio*max_size)+"px");
		if (jQuery("div.Zoom5 div.Zoom5_content > *").css("width")) {
			jQuery("div.Zoom5 div.Zoom5_content > *").css("width",Math.floor(o_width/ratio*max_size)+"px");
		}
	}

	setTimeout(function() {
		jQuery("div.Zoom5 div.Zoom5_content").css("visibility","visible");
		//jQuery("div.Zoom5 div.content").hide();
		//jQuery("div.Zoom5 div.content").fadeIn(100);
	},1);

	return this;
};


Zoom5.next = function(objects) {

	if (Zoom5.opened == false)
		return false;

	var count = objects.length;

	if (count <= 1)
		return false;

	Zoom5.current = ++Zoom5.current%count;
	Zoom5.init(objects,Zoom5.current);
};


Zoom5.prev = function(objects) {

	if (Zoom5.opened == false)
		return false;

	var count = objects.length;

	if(count <= 1)
		return false;

	Zoom5.current = (count+(--Zoom5.current))%count;
	Zoom5.init(objects,Zoom5.current);
};


Zoom5.content_type = function(file, callback) {

	if (file.match(/blob:(.+)/)) {

		var xhr = new XMLHttpRequest();
		xhr.open('GET', file, true);
		xhr.responseType = 'blob';
		xhr.onload = function(e) {
		  if (this.status == 200) {
		    var blob = this.response;
				var type = blob.type;
				type = type.match(/([^\/]+)\/(.+)/);
				callback([type[1],type[2]]);
		  }
		};
		xhr.send();
	}

	else{

		var filetype = Zoom5.filetype(file);

			var image = ["png","jpeg","jpg","gif","webp"];
			var video = ["mp4","webm","quicktime","ogg"];

		if(image.indexOf(filetype) >= 0)
			callback(["image",filetype]);
		else if(video.indexOf(filetype) >= 0)
			callback(["video",filetype]);
		else
			callback(["html",filetype]);
	}
};


Zoom5.filetype = function(file){

	var file = file.toLowerCase().split(".").pop().split("?").shift();
	var array = new Array();
	array["mov"] = "mp4";

	if(file in array)
		return array[file];
	else
		return file;

};

(function(win) {

    var listeners = [],
    doc = win.document,
    MutationObserver = win.MutationObserver || win.WebKitMutationObserver,
    observer;

    function ready(selector, fn) {
        // Store the selector and callback to be monitored
        listeners.push({
            selector: selector,
            fn: fn
        });
        if (!observer) {
            // Watch for changes in the document
            observer = new MutationObserver(check);
            observer.observe(doc.documentElement, {
                childList: true,
                subtree: true
            });
        }
        // Check if the element is currently in the DOM
        check();
    }

    function check() {
        // Check the DOM for elements matching a stored selector
        for (var i = 0, len = listeners.length, listener, elements; i < len; i++) {
            listener = listeners[i];
            // Query for elements matching the specified selector
            elements = doc.querySelectorAll(listener.selector);
            for (var j = 0, jLen = elements.length, element; j < jLen; j++) {
                element = elements[j];
                // Make sure the callback isn't invoked with the
                // same element more than once
                if (!element.ready) {
                    element.ready = true;
                    // Invoke the callback with the element
                    listener.fn.call(element, element);
                }
            }
        }
    }

    // Expose `ready`
    win.ready = ready;

})(this);


Zoom5.load();