<?php
//Create Intance of Core Class
//Exit on failure

if(
	file_exists('library/core.classes.php') &&
	(include("library/core.classes.php")) &&
	$core = new KB_core("backend")){}
else{
	header("HTTP/1.1 503 Service Unavailable");
	header("Status: 503 Service Temporarily Unavailable");
	exit(1);
}

require_once "library/ixr.classes.php";

// http://archipelago.phrasewise.com/rsd
if ($core->get_var('rsd') !== false)
{
	header('Content-Type: text/xml; charset=utf-8', true);
	$s_id	= $core->get_var('s_id')	!== false ? '?s_id='.	$core->get_var('s_id')		: '';
	$s_path	= $core->get_var('s_path')	!== false ? '&amp;s_path='.	$core->get_var('s_path')	: '';

	echo
'<?xml version="1.0" encoding="utf-8"?>
	<rsd version="1.0" xmlns="http://archipelago.phrasewise.com/rsd">
	  <service>
	    <engineName>Kitbooth</engineName>
	    <engineLink>http://www.kitbooth.com</engineLink>
	    <homePageLink>http://'.$_SERVER["SERVER_NAME"].'/'.$core->get_var('s_path').'</homePageLink>
	    <apis>
			<api name="MetaWeblog"	blogID="'.$core->get_var('s_id').'" preferred="true"	apiLink="http://'.$_SERVER["SERVER_NAME"].$_SERVER['PHP_SELF'].$s_id.$s_path.'" />
			<api name="Blogger"		blogID="'.$core->get_var('s_id').'" preferred="false"	apiLink="http://'.$_SERVER["SERVER_NAME"].$_SERVER['PHP_SELF'].$s_id.$s_path.'" />
	    </apis>
	  </service>
	</rsd>
';
	exit;
}
if ($core->get_var('wlw') !== false)
{
	header('Content-Type: text/xml; charset=utf-8', true);
	echo
'<?xml version="1.0" encoding="utf-8"?>
	<manifest xmlns="http://schemas.microsoft.com/wlw/manifest/weblog">
		<options>
			<clientType>Kitbooth</clientType>
			<supportsPostAsDraft>No</supportsPostAsDraft>
			<supportsFileUpload>Yes</supportsFileUpload>
			<supportsMultipleCategories>No</supportsMultipleCategories>
			<supportsHierarchicalCategories>Yes</supportsHierarchicalCategories>
			<supportsGetTags>No</supportsGetTags>
			<supportsNewCategories>Yes</supportsNewCategories>
			<supportsNewCategoriesInline>No</supportsNewCategoriesInline>
			<supportsKeywords>Yes</supportsKeywords>
			<supportsPageOrder>No</supportsPageOrder>
			<supportsEmptyTitles>No</supportsEmptyTitles>
			<supportsScripts>Yes</supportsScripts>
		</options>
		<weblog>
			<serviceName>Kitbooth</serviceName>
			<imageUrl>http://'.$_SERVER["SERVER_NAME"].BACKEND_TEMPLATE.'favicon.png</imageUrl>
			<homepageLinkText>Im Browser anzeigen</homepageLinkText>
	    <adminLinkText>Backend</adminLinkText>
	    <adminUrl>http://'.$_SERVER["SERVER_NAME"].'/backend/</adminUrl>
	  </weblog>
	</manifest>
';
	exit;
}

class kb_xmlrpc_server extends IXR_Server {


	function __construct() {



		global $core;
		$this->core			= $core;//new KB_core;
		$this->db			= $this->core->db_o();
		$this->user			= $this->core->user_o();

		if($core->get_var("username") != "" && $core->get_var("password") != "" && $user->user_check($core->get_var("username"), $core->get_var("password"))){
		}

		$this->structures	= $this->core->structure_o();
		$this->blog_ID		= $this->core->get_var('s_id') !== false ? $this->core->get_var('s_id') : false;
		if($this->blog_ID) $this->structures->set_root($this->blog_ID);
		$this->contents		= $this->core->content_o();
		$this->templates	= $this->core->template_o();
		$this->filesystem	= $this->core->filesystem_o();

		$this->methods = array(

			// Blogger API
			'blogger.getUsersBlogs' => 'this:blogger_getUsersBlogs',
			'blogger.getUserInfo' => 'this:blogger_getUserInfo',
			'blogger.getPost' => 'this:blogger_getPost',
			'blogger.getRecentPosts' => 'this:blogger_getRecentPosts',
			'blogger.getTemplate' => 'this:blogger_getTemplate',
			'blogger.setTemplate' => 'this:blogger_setTemplate',
			'blogger.newPost' => 'this:blogger_newPost',
			'blogger.editPost' => 'this:blogger_editPost',
			'blogger.deletePost' => 'this:blogger_deletePost',

			// MetaWeblog API (with MT extensions to structs)
			'metaWeblog.newPost' => 'this:mw_newPost',
			'metaWeblog.editPost' => 'this:mw_editPost',
			'metaWeblog.getPost' => 'this:mw_getPost',
			'metaWeblog.getRecentPosts' => 'this:mw_getRecentPosts',
			'metaWeblog.getCategories' => 'this:mw_getCategories',
			'metaWeblog.newMediaObject' => 'this:mw_newMediaObject',

			// MetaWeblog API aliases for Blogger API
			// see http://www.xmlrpc.com/stories/storyReader$2460
			'metaWeblog.deletePost'		=> 'this:blogger_deletePost',
			'metaWeblog.getTemplate'	=> 'this:blogger_getTemplate',
			'metaWeblog.setTemplate'	=> 'this:blogger_setTemplate',
			'metaWeblog.getUsersBlogs'	=> 'this:blogger_getUsersBlogs',

			//Movable Type API
			'mt.getPostCategories'		=> 'this:mt_getPostCategories',
			'mt.setPostCategories'		=> 'this:mt_setPostCategories',

			//Wordpress Aliase
			'wp.getCategories'			=> 'this:mw_getCategories',		// Alias
			'wp.newCategory'			=> 'this:kb_newCategory',




		);

		$this->IXR_Server($this->methods);
	}

// General Functions

	// Check if User has Rights

	function check_rights($username, $password)
	{
		$login = false;

		if($this->user->user_check($username, $password)) $login = true;

		if($this->core->get_config("user_group_has_structure",$this->user->group_data("ID")) !== false
			&&
			!in_array(
				$this->blog_ID,array_merge(
					array($this->core->get_config("user_group_has_structure",$this->user->group_data("ID"))),$this->structures->read_children($this->core->get_config("user_group_has_structure",$this->user->group_data("ID")))
				)
			)
		) $login = false;

		return $login;
	}

// Blogger API

	function blogger_getUsersBlogs($args)
	{
		$username = $args[1];
		$password  = $args[2];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			$structure	= $this->structures->read_per("ID",$this->blog_ID,1);
			$template = $this->templates->read_per("ID",$structure['template_ID'],1);
			$struct[] = array(
						'isAdmin'  => true,
						'url'      => 'http://'.$_SERVER["SERVER_NAME"].'/'.$this->core->get_var('s_path'),//get_option('home') . '/',
						'blogName' => $template["name"],//get_option('blogname'),
						'blogid'   => $this->blog_ID,
						'xmlrpc'   => 'http://'.$_SERVER["SERVER_NAME"].'/xmlrpc.php',
					);
			return $struct;
		}
	}

	// Retrieve user's data.

	function blogger_getUserInfo($args) {

		$username = $args[1];
		$password  = $args[2];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			$user_data = $this->user->get_user_data();

			$struct = array(
				'nickname'  => $user_data["name"],
				'userid'    => $user_data["ID"],
			//	'url'       => $user->user_url,
			//	'lastname'  => $user->last_name,
			//	'firstname' => $user->first_name
			);

			return $struct;
		}
	}

	// Retrieve post.

	function blogger_getPost($args) {


		$post_ID	= (int) $args[1];
		$username	= $args[2];
		$password	= $args[3];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you cannot edit this post.');
		}
		else
		{
			$content = $this->contents->read_per("ID",$content_ID,1);

			$categories = "";

			$user_data = $this->user->get_user_data();

			$contents  = '<title>'.$content["name"].'</title>';
			$contents .= '<category>'.$categories.'</category>';
			$contents .= $content['content'];

			$struct = array(
				'userid'			=> $user_data['ID'],
				'dateCreated'		=> date("c",strtotime($content["updated"])),
				'content'			=> $contents,
				'title'				=> $contents["name"],
				'postid'			=> $content["ID"],
			);

			return $struct;
		}
	}

	//

	function blogger_getRecentPosts($args) {

		$blog_ID	= (int) $args[1];
		$username	= $args[2];
		$password	= $args[3];
		$limit = (isset($args[4])) ? (int) $args[4] : false;

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you cannot edit this post.');
		}
		else
		{

			// Set Limit
			if($limit) $this->contents->set_limit(false,$limit);

			// Set Order
			$this->contents->add_order("updated DESC");

			// Read all
			$contents = $this->contents->read_all();

			foreach($contents as $key => $content)
			{
				if($this->contents->secured($content['ID'])) unset($contents[$key]);
			}

			$contents = array_merge($contents);

			// Create Array
			foreach($contents as $key => $content)
			{
			//	$content  = '<title>'.stripslashes($entry['post_title']).'</title>';
			//	$content .= '<category>'.$categories.'</category>';
			//	$content .= stripslashes($entry['post_content']);

			//	$post_date = mysql2date('Ymd\TH:i:s', $entry['post_date'], false);
			//	$categories = implode(',', wp_get_post_categories($entry['ID']));

				$description = $content["name"] == $content["meta_title"] ? strip_tags($content["content"]) : $content["meta_title"].'<br>'.strip_tags($content["content"]);
				$recent_posts[$key] = array(
					'dateCreated'	=> date("c",strtotime($content["updated"])),
					'postid'		=> $content["ID"],
					'title'			=> $content["name"],
					'content'		=> $description,
					'userid'		=> $username,
					//'dateCreated'	=> new IXR_Date($post_date),
				);

			}
			return $recent_posts;
		}
	}

	/**
	 * Retrieve blog_filename content.
	 *
	 * @since 1.5.0
	 *
	 * @param array $args Method parameters.
	 * @return string

	function blogger_getTemplate($args) {

		$this->escape($args);

		$blog_ID    = (int) $args[1];
		$username = $args[2];
		$password  = $args[3];
		$template   = $args[4]; // could be 'main' or 'archiveIndex', but we don't use it

		if ( !$user = $this->login($username, $password) ) {
			return $this->error;
		}

		do_action('xmlrpc_call', 'blogger.getTemplate');

		if ( !current_user_can('edit_themes') ) {
			return new IXR_Error(401, __('Sorry, this user can not edit the template.'));
		}

		// warning: here we make the assumption that the blog's URL is on the same server
		$filename = get_option('home') . '/';
		$filename = preg_replace('#https?://.+?/#', $_SERVER['DOCUMENT_ROOT'].'/', $filename);

		$f = fopen($filename, 'r');
		$content = fread($f, filesize($filename));
		fclose($f);

		// so it is actually editable with a windows/mac client
		// FIXME: (or delete me) do we really want to cater to bad clients at the expense of good ones by BEEPing up their line breaks? commented.     $content = str_replace("\n", "\r\n", $content);

		return $content;
	}

	/**
	 * Updates the content of blog_filename.
	 *
	 * @since 1.5.0
	 *
	 * @param array $args Method parameters.
	 * @return bool True when done.

	function blogger_setTemplate($args) {

		$this->escape($args);

		$blog_ID    = (int) $args[1];
		$username = $args[2];
		$password  = $args[3];
		$content    = $args[4];
		$template   = $args[5]; // could be 'main' or 'archiveIndex', but we don't use it

		if ( !$user = $this->login($username, $password) ) {
			return $this->error;
		}

		do_action('xmlrpc_call', 'blogger.setTemplate');

		if ( !current_user_can('edit_themes') ) {
			return new IXR_Error(401, __('Sorry, this user cannot edit the template.'));
		}

		// warning: here we make the assumption that the blog's URL is on the same server
		$filename = get_option('home') . '/';
		$filename = preg_replace('#https?://.+?/#', $_SERVER['DOCUMENT_ROOT'].'/', $filename);

		if ($f = fopen($filename, 'w+')) {
			fwrite($f, $content);
			fclose($f);
		} else {
			return new IXR_Error(500, __('Either the file is not writable, or something wrong happened. The file has not been updated.'));
		}

		return true;
	}

	/**
	 * Create new post.
	 *
	 * @since 1.5.0
	 *
	 * @param array $args Method parameters.
	 * @return int

	function blogger_newPost($args) {

		$this->escape($args);

		$blog_ID    = (int) $args[1]; // though we don't use it yet
		$username = $args[2];
		$password  = $args[3];
		$content    = $args[4];
		$publish    = $args[5];

		if ( !$user = $this->login($username, $password) ) {
			return $this->error;
		}

		do_action('xmlrpc_call', 'blogger.newPost');

		$cap = ($publish) ? 'publish_posts' : 'edit_posts';
		if ( !current_user_can($cap) )
			return new IXR_Error(401, __('Sorry, you are not allowed to post on this blog.'));

		$post_status = ($publish) ? 'publish' : 'draft';

		$post_author = $user->ID;

		$post_title = xmlrpc_getposttitle($content);
		$post_category = xmlrpc_getpostcategory($content);
		$post_content = xmlrpc_removepostdata($content);

		$post_date = current_time('mysql');
		$post_date_gmt = current_time('mysql', 1);

		$post_data = compact('blog_ID', 'post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_title', 'post_category', 'post_status');

		$post_ID = wp_insert_post($post_data);
		if ( is_wp_error( $post_ID ) )
			return new IXR_Error(500, $post_ID->get_error_message());

		if (!$post_ID)
			return new IXR_Error(500, __('Sorry, your entry could not be posted. Something wrong happened.'));

		$this->attach_uploads( $post_ID, $post_content );

		logIO('O', "Posted ! ID: $post_ID");

		return $post_ID;
	}

	/**
	 * Edit a post.
	 *
	 * @since 1.5.0
	 *
	 * @param array $args Method parameters.
	 * @return bool true when done.

	function blogger_editPost($args) {

		$this->escape($args);

		$post_ID     = (int) $args[1];
		$username  = $args[2];
		$password   = $args[3];
		$content     = $args[4];
		$publish     = $args[5];

		if ( !$user = $this->login($username, $password) ) {
			return $this->error;
		}

		do_action('xmlrpc_call', 'blogger.editPost');

		$actual_post = wp_get_single_post($post_ID,ARRAY_A);

		if (!$actual_post || $actual_post['post_type'] != 'post') {
			return new IXR_Error(404, __('Sorry, no such post.'));
		}

		$this->escape($actual_post);

		if ( !current_user_can('edit_post', $post_ID) )
			return new IXR_Error(401, __('Sorry, you do not have the right to edit this post.'));

		extract($actual_post, EXTR_SKIP);

		if ( ('publish' == $post_status) && !current_user_can('publish_posts') )
			return new IXR_Error(401, __('Sorry, you do not have the right to publish this post.'));

		$post_title = xmlrpc_getposttitle($content);
		$post_category = xmlrpc_getpostcategory($content);
		$post_content = xmlrpc_removepostdata($content);

		$postdata = compact('ID', 'post_content', 'post_title', 'post_category', 'post_status', 'post_excerpt');

		$result = wp_update_post($postdata);

		if (!$result) {
			return new IXR_Error(500, __('For some strange yet very annoying reason, this post could not be edited.'));
		}
		$this->attach_uploads( $ID, $post_content );

		return true;
	}


	/**
	 * Remove a post.
	 *
	 * @since 1.5.0
	 *
	 * @param array $args Method parameters.
	 * @return bool True when post is deleted.
*/
	function blogger_deletePost($args) {

		//$args = $this->escape($args);

		$post_ID	= (int) $args[1];
		$username	= $args[2];
		$password	= $args[3];
		$publish	= $args[4];

		$login = $this->check_rights($username,$password);

		if(!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			$post = $this->contents->read_per('ID',$post_ID,1);
			$this->contents->to_last_pos($post['position'],array('group_ID'=>$post['group_ID']));
			if($this->contents->delete($post_ID))
			{
				return true;
			}
			else
			{
				$this->error('404', 'Sorry, there’s no such post to delete.');
			}
		}

	}

// MetaWeblog API functions

	// New Post

	function mw_newPost($args) {

		$blog_ID		= (int) $args[0];
		$username		= $args[1];
		$password		= $args[2];
		$content_struct	= $args[3];
		$publish		= $args[4];

		$login = $this->check_rights($username,$password);

		if(empty($content_struct['title']) || $content_struct['title'] == "")
		{
			$this->error('401', 'Sorry, you do have to set at least a page title.');
			$login = false;
		}
		if(!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			$values = array(
				'name'			=> html_entity_decode(str_replace("'", "\'", htmlspecialchars_decode($content_struct['title'],ENT_QUOTES)),ENT_NOQUOTES,'UTF-8'),
				'content'		=> str_replace("'", "\'", htmlspecialchars_decode($content_struct['description'],ENT_QUOTES)),
				'group_ID'	=> $blog_ID,
				'filealias'		=> url_encode(html_entity_decode(str_replace("'", "\'", htmlspecialchars_decode($content_struct['title'],ENT_QUOTES)),ENT_NOQUOTES,'UTF-8')).'.html',
				//'created'		=> 'NOW()'
			);
			if(empty($content_struct['categories']) || preg_match("/([(])([0-9]{1,})(.*)/",$content_struct['categories'][0])){
				$category = !empty($content_struct['categories']) && preg_match("/([(])([0-9]{1,})(.*)/",$content_struct['categories'][0]) ? preg_replace("/([(])([0-9]{1,})(.*)/","$2",$content_struct['categories'][0]) : $blog_ID;
				$this->contents->add_order("position DESC");
				$contents = $this->contents->read_per("group_ID",$category,1);
				$values['position'] = $contents["position"]+1;
			}
			if(!empty($content_struct['mt_keywords'])){
				$values['meta_keywords'] = $content_struct['mt_keywords'];
			}
			if(!empty($content_struct['categories']) && preg_match("/([(])([0-9]{1,})(.*)/",$content_struct['categories'][0])){
				$values['group_ID'] = preg_replace("/([(])([0-9]{1,})(.*)/","$2",$content_struct['categories'][0]);
			}
			if(isset($content_struct['dateCreated'])){
				$values['created'] = date('Y-m-d H:i:s', $content_struct['dateCreated']->getTimestamp());
			}

			$post_ID = $this->contents->create($values);

			if($post_ID){
				return strval($post_ID);
			}else{
				$this->error('400','Bad Request.');
			}

		/*	$sql ="INSERT INTO ".DB_PREFIX."kb_content (position,name,content,structure_ID,is_file,filealias,secure,created) VALUES
					(".$highest_pos.",'".html_entity_decode($content_struct['title'], ENT_QUOTES, 'UTF-8')."', '".$content_struct['description']."', ".$blog_ID.",0,'".str_replace(" ","-",strtolower($content_struct['title'])).".html',0,NOW()) ";
			$post_ID = $this->db->sql_insert($sql);
		*/


		}
	}
// Edit a post.
	function mw_editPost($args) {


		$post_ID     = (int) $args[0];
		$username  = $args[1];
		$password   = $args[2];

		$content_struct = $args[3];
		$publish     = $args[4];

		//$content_struct['description'] = htmlspecialchars_decode($content_struct['description'],ENT_QUOTES);
		//TODO: $content_struct['description'] = preg_replace("/char(9)/","\t",$content_struct['description']);
		//$content_struct['description'] = preg_replace("/char(10)/","\n",$content_struct['description']);
		//TODO: $content_struct['description'] = preg_replace("/([^a-zA-Z<>0-9]){1}/e",'-'.'ord("$1")',$content_struct['description']);

	    $login = $this->check_rights($username,$password);

		if(!$login)
		{
			$this->error('401','Sorry, you do not have access to this web site.');
		}
		else
		{


			$values = array(
				'name'			=> htmlspecialchars_decode($content_struct['title'],ENT_QUOTES),
				'content'		=> $content_struct['description'],
				'ID'			=> $post_ID,
			);
			if(!empty($content_struct['mt_keywords'])){
				$values['meta_keywords'] = $content_struct['mt_keywords'];
			}
			if(!empty($content_struct['categories']) && preg_match("/([(])([0-9]{1,})(.*)/",$content_struct['categories'][0])){
				$values['group_ID'] = preg_replace("/([(])([0-9]{1,})(.*)/","$2",$content_struct['categories'][0]);
			}
			if(isset($content_struct['dateCreated'])){
				$values['created'] = date('Y-m-d H:i:s', $content_struct['dateCreated']->getTimestamp());
			}
			if(!$this->contents->update($values)){
				$this->error('400','Bad Request.');
			}

		}

	}
// Retrieve post.
	function mw_getPost($args) {

		//$args = $this->escape($args);

		$content_ID	= (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			// Read Content
			$content = $this->contents->read_per("ID",$content_ID,1);
			// Create Array
			$content_array = array(
				'dateCreated'		=> date("c",strtotime($content["updated"])),
				'postid'			=> $content["ID"],
				'title'				=> $content["name"],
				//'description'		=> $content["name"],
				'link'				=> 'http://'.$_SERVER["SERVER_NAME"].'/'.$this->core->get_var('s_path').$content["filealias"],
				'permaLink'			=> 'http://'.$_SERVER["SERVER_NAME"].'/'.$this->core->get_var('s_path').$content["filealias"],
				'description'		=> $content['content'],
				'publish'			=> $content['secure'] == 1 ? false : true,
				'categories'		=> $content['group_ID'],
				'mt_allow_pings'	=> 0,
				'mt_allow_comments'	=> 0,
				'mt_keywords'		 => $content['meta_keywords'],
				//'wp_page_order'	=> '1',
			);
			return $content_array;
		}
	}
// Retrieve list of recent posts
	function mw_getRecentPosts($args) {

		$blog_ID	= (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];
		if (isset($args[3])) $limit	= (int) $args[3];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you do not have access to this web site.');
		}
		else
		{
			// Set Limit
			if(isset($limit)) $this->contents->set_limit(false,$limit);

			// Set Filters
			$s_ids = ($this->structures->has_child($this->core->get_var('s_id'))) ? $this->core->get_var('s_id').','.implode(",",$this->structures->read_children($this->core->get_var('s_id'))) : $this->core->get_var('s_id');
			$this->contents->add_filter("group_ID IN (".$s_ids.")");

			// Set Order
			$this->contents->add_order("updated DESC");

			// Read all
			$contents = $this->contents->read_all();

			// Create Array
			foreach($contents as $key => $content)
			{
				if($this->contents->secured($content['ID'])) unset($contents[$key]);
			}

			$contents = array_merge($contents);

			foreach($contents as $key => $content)
			{
				$description = $content["name"] == $content["meta_title"] ? strip_tags($content["content"]) : $content["meta_title"].'<br>'.strip_tags($content["content"]);
				$recent_posts[$key] = array(
					'dateCreated'	=> date("c",strtotime($content["updated"])),
					'postid'		=> $content["ID"],
					'title'			=> $content["name"],
					'description'	=> $description,
					'link'			=> 'http://'.$_SERVER["SERVER_NAME"].'/'.$this->core->get_var('s_path').$content["filealias"],
					'permaLink'		=> 'http://'.$_SERVER["SERVER_NAME"].'/'.$this->core->get_var('s_path').$content["filealias"],
					'categories'	=> $content['group_ID'],
					'mt_keywords'	=> $content['meta_keywords'],
				);
			}
			return $recent_posts;
		}
	}

// Retrieve the list of categories on a given blog.
	function mw_getCategories($args) {

		//$this->escape($args);

		$blog_ID	= (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you must be able to edit posts on this blog in order to view categories.');
		}
		else
		{
			//$structures = $this->structures->read_children($blog_ID);


			$structures = $this->structures->read_dropdown();
			$count = count($structures);
			$count = strlen($count);

			//$s_path = $this->core->get_var('s_path') !== false ? $this->core->get_var('s_path') : '';
			$i=0;
			foreach ($structures as $key => $name)
			{
				$structure = $this->structures->read_per("ID",$key,1);

				$categories_array[$i++] = array
				(
					'title'					=> "(".$structure["ID"].") ".$structure["name"],
					'description'			=> $structure["name"],
					'categoryId'			=> (int) $structure["ID"],
					'parentId'				=> (int) $structure["parent_ID"],
					'categoryName'			=> sprintf("%0".$count."d", $i).$name,
				);
			}

			return empty($categories_array) ? array() : $categories_array;
		}
	}

// Uploads a file, following your settings.
	function mw_newMediaObject($args) {
		//$this->escape($args);

		$blog_ID	= (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];
		$data		= $args[3];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you must be able to edit posts on this blog in order to upload files.');
		}
		else
		{
			$file_tmp	= explode("/",$data['name']);
			$file_tmp	= array_pop($file_tmp);

			$file_tmp	= explode(".",$file_tmp);
			$file_ext	= array_pop($file_tmp);

			$filename	= implode("-",$file_tmp);
			$filename	= url_encode($filename);
			$filename	= $filename.".".$file_ext;

			unset($file_tmp);

			$base_dir = FRONTEND_FOLDER."files/";

			$folder = "s-".$blog_ID."/";

			$this->filesystem->set_base_dir($base_dir);
			$this->filesystem->delete_file($folder.$filename, false);
			$this->filesystem->create_file($filename, $folder, $data['bits']);

			$url = '/'.$folder.$filename;

			$type = $data['type'];

			return array('file' => $filename, 'url' => $url, 'type' => $type );
		}
	}

// Movable Type

// getPostCategories
	function mt_getPostCategories($args) {

		$post_ID     = (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you must be able to edit posts on this blog in order to view categories.');
		}
		else
		{

			$content	= $this->contents->read_per("ID",$post_ID,1);
			$structure	= $this->structures->read_per("ID",$content["group_ID"],1);

			$category_array[0] = array //API always expects an array, even if Kitbooth just supports one category
			(
				'categoryId'			=> $content["group_ID"],
				'categoryName'			=> $structure["name"],
				'isPrimary'				=> true,
			);

			return $category_array;
		}
	}
//Sets categories for a post.
	function mt_setPostCategories($args) {

		$post_ID     = (int) $args[0];
		$username  = $args[1];
		$password   = $args[2];
		$categories  = $args[3];

		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you must be able to edit posts on this blog in order to set categories.');
		}
		else{

			if(!empty($categories)){
				$values = array(
					'ID'			=> $post_ID,
					'group_ID'	=> $categories[0]["categoryId"]
				);

			}else{
				$values = array(
					'ID'			=> $post_ID,
					'group_ID'	=> $this->blog_ID
				);
			}

			$post = $this->contents->read_per("ID",$post_ID,1);

			//$this->contents->to_last_pos($post['position'],array('structure_ID'=>$post['structure_ID']));

			if(!empty($categories) && $categories[0]["categoryId"] != $post['group_ID']){


				$category = !empty($categories) ? $categories[0]["categoryId"] : $this->blog_ID;
				$contents = $this->contents->read_per("group_ID",$category);
				$highest_pos = 0;
				foreach($contents as $array){
					if($array['position'] > $highest_pos) $highest_pos = $array['position'];
				}
				$highest_pos++;
				$values['position'] = $highest_pos;

				$this->contents->update($values);
			}
			return true;
		}
	}

//Kitbooth API

	//New Category (Structure)
	function kb_newCategory($args){

		$blog_id	= (int) $args[0];
		$username	= $args[1];
		$password	= $args[2];
		$category	= $args[3];


		$login = $this->check_rights($username,$password);

		if (!$login)
		{
			$this->error('401', 'Sorry, you must be able to edit posts on this blog in order to view categories.');
		}
		else
		{
			$values = array(
				'name'		=> $category["name"],
				'url_path_name'	=> url_encode($category["name"]),
				'parent_ID'	=> empty($category["parent_id"]) ? $this->blog_ID : $category["parent_id"]
			);
			$new_ID = $this->structures->create($values);
			return $new_ID;
		}
	}
}


$kb_xmlrpc_server = new kb_xmlrpc_server();

?>
