<?php

// Backup filter
$filter_backup = $data->filter();

if ($on_empty = key_of("on_empty",$kit["kit_option"]))
  unset($kit["kit_option"]["on_empty"]);

// $correlation_o = $core->correlation_o();

switch (key_of("select",$kit["kit_option"])){

  case "data":

		if ($foreign = key_of("foreign",$kit["kit_option"]))
			$data->foreign($foreign);

		if ($correlation = key_of("correlation",$kit["kit_option"]))
			$data->correlation(true);

		$include = NULL;
		$exclude = NULL;

		if ($entry_select = either(key_of("entry_select",$kit["kit_option"]), key_of("filter_select",$kit["kit_option"]))) {
			$entry_select = $parse_function($entry_select);
			$entry_select = $data->entry($entry_select);
		}

		if ($filter = key_of("filter",$kit["kit_option"])) {

			$filter = $parse_var($filter,$entry_select);
			$filter = $parse_function($filter);

			if (are_empty($include = key_of("include",$filter), $exclude = key_of("exclude",$filter))) {
				$include = $filter;
				$data->filter(keys_of(array_keys($data->columns()),$include));
				$include = remove_keys_of(array_keys($data->columns()),$include);
			}

			else {

				if (not_empty($include)) {
					$data->filter(keys_of(array_keys($data->columns()),$include));
					$include = remove_keys_of(array_keys($data->columns()),$include);
				}

				if (not_empty($exclude)) {
					$data->exclude(keys_of(array_keys($data->columns()),$exclude));
					$exclude = remove_keys_of(array_keys($data->columns()),$exclude);
				}
			}
		}

		else if ($ID = key_of("ID", key_of("kit_option", $kit))) {
			$data->filter(["ID" => $ID]);
		}

		else if ($group_ID = key_of("group_ID", key_of("kit_option", $kit))) {
			$data->filter(["group_ID" => $group_ID]);
		}

		$array = $data->read();

		if (not_empty($include)){
			if ($core->array->has_regex($include))
				$array = $core->array->find($array,$include);
			else
				$array = $core->array->filter($array,$include);
		}

		if (not_empty($exclude))
			$array = $core->array->diff(
				$array,
				$core->array->filter($array,$exclude)
			);


    if (
			($range = key_of("range",$kit["kit_option"])) &&
			is_array($range)
		) {

			$range = $parse_var($range,$entry_select);

			foreach ($range as $column => $values) {
        $values = $parse_function($values);
        $array = $core->array->range_by($array,$column,$values);
      }
    }

    if ($sort = key_of("sort",$kit["kit_option"]))
      $array = $core->array->sort_by($array,$sort);


    if (key_of("order",$kit["kit_option"]) == "descending")
      $array = array_reverse($array,true);

    if (key_of("order",$kit["kit_option"]) == "shuffle")
      $array = array_shuffle($array);

    if ($limit = key_of("limit",$kit["kit_option"])) {
			if (is_indexed($limit) && count($limit) == 2)
				$array = array_slice($array,$limit[0],$limit[1],true);
			else
      	$array = array_slice($array,0,intval($limit),true);
		}

    reset($array);

    break;

  case "groups":

      // $array = $data->group->read();

			if ($foreign = key_of("foreign",$kit["kit_option"]))
				$data->group->foreign($foreign);

			if ($correlation = key_of("correlation",$kit["kit_option"]))
				$data->group->correlation = true;

			$include = NULL;
			$exclude = NULL;

      if ($filter = key_of("filter",$kit["kit_option"])){

				$filter = $parse_function($filter);

				if (are_empty($include = key_of("include",$filter), $exclude = key_of("exclude",$filter))) {
					$include = $filter;
					$data->group->filter(keys_of(array_keys($data->columns()),$include));
					$include = remove_keys_of(array_keys($data->columns()),$include);
				}

        else {

					if (not_empty($include)) {
						$data->group->filter(keys_of(array_keys($data->columns()),$include));
						$include = remove_keys_of(array_keys($data->columns()),$include);
					}

					if (not_empty($exclude)) {
						$data->group->exclude(keys_of(array_keys($data->columns()),$exclude));
						$exclude = remove_keys_of(array_keys($data->columns()),$exclude);
					}

        }
      }

			else if ($ID = key_of("ID", key_of("kit_option", $kit))) {
				$data->group->filter(["ID" => $ID]);
			}

			$array = $data->group->read();

			if (not_empty($include)){
				if ($core->array->has_regex($include))
					$array = $core->array->find($array,$include);
				else
					$array = $core->array->filter($array,$include);
			}

			if (not_empty($exclude))
				$array = $core->array->diff(
					$array,
					$core->array->filter($array,$exclude)
				);


      if ($range = key_of("range",$kit["kit_option"])) {
        foreach($range as $column => $values){
          $values = $parse_function($values);
          $array = $core->array->range_by($array,$column,$values);
        }
      }

      if ($sort = key_of("sort",$kit["kit_option"]))
        $array = $core->array->sort_by($array,$sort);

      if (key_of("order",$kit["kit_option"]) == "descending")
        $array = array_reverse($array,true);

			if (key_of("order",$kit["kit_option"]) == "shuffle")
	      $array = array_shuffle($array);

      if($limit = key_of("limit",$kit["kit_option"])) {
				if (is_indexed($limit) && count($limit) == 2)
					$array = array_slice($array,$limit[0],$limit[1],true);
				else
	      	$array = array_slice($array,0,int($limit),true);
			}

      reset($array);

    break;

    case "data_and_groups":

			if ($foreign = key_of("foreign",key_of("groups", $kit["kit_option"])))
				$data->group->foreign($foreign);

			if ($foreign = key_of("foreign",key_of("data", $kit["kit_option"])))
				$data->foreign($foreign);

      $array["groups"] = $data->group->read();
			/*
      if ($filter = key_of("filter",key_of("groups",$kit["kit_option"]))) {
        $filter = $parse_function($filter);
        $array["groups"] = $core->array->filter_by($array["groups"],$filter);
      }
			*/
      if ($filter = key_of("filter",key_of("groups",$kit["kit_option"]))) {

				$filter = $parse_function($filter);

				if (are_empty($include = key_of("include",$filter), $exclude = key_of("exclude",$filter))) {
          $array["groups"] = $core->array->filter_by($array["groups"],$filter);
        }

        else {

          if (not_empty($include))
            $array["groups"] = $core->array->filter($array["groups"],$include);

          if (not_empty($exclude))
            $array["groups"] = $core->array->diff(
              $array["groups"],
              $core->array->filter($array["groups"],$exclude)
            );

        }
      }

      if($limit = key_of("limit",key_of("groups",$kit["kit_option"])))
        $array["groups"] = array_slice($array["groups"],0,$limit,true);

      if (is_empty($array["groups"]) && not_empty($on_empty_groups = key_of("on_empty",key_of("groups",$kit["option"])))) {
        $array["groups"] = $data->group->read();

        if($sort = key_of("sort",key_of("on_empty",key_of("groups",$kit["kit_option"]))))
          $array["groups"] = $core->array->sort_by($array["groups"],$sort);

        if ($filter = key_of("filter",key_of("on_empty",key_of("groups",$kit["option"])))) {
          $filter = $parse_function($filter);
          $array["groups"] = $core->array->filter_by($array["groups"],$filter);
        }

        if($limit = key_of("limit",key_of("on_empty",key_of("groups",$kit["kit_option"]))))
          $array["groups"] = array_slice($array["groups"],0,$limit,true);
      }

      if(!empty($array["groups"]))
        $array["data"] = $data->read(array("group_ID"=>key_fetch("ID",$array["groups"])));
      else
        $array["data"] = array();

      if($filter = key_of("filter",key_of("data",$kit["kit_option"]))){

        $filter = $parse_function($filter);

        if (are_empty($include = key_of("include",$filter), $exclude = key_of("exclude",$filter))) {
          $array["data"] = $core->array->filter_by($array["data"],$filter);
        }

        else {

          if (not_empty($include))
            $array["data"] = $core->array->filter($array["data"],$include);

          if (not_empty($exclude))
            $array["data"] = $core->array->diff(
              $array["data"],
              $core->array->filter($array["data"],$exclude)
            );

        }
      }

      if($sort = key_of("sort",key_of("groups",$kit["kit_option"])))
        $array["groups"] = $core->array->sort_by($array["groups"],$sort);

      if($sort = key_of("sort",key_of("data",$kit["kit_option"])))
        $array["data"] = $core->array->sort_by($array["data"],$sort);

      if(key_of("order",key_of("groups",$kit["kit_option"])) == "descending")
        $array["groups"] = array_reverse($array["groups"]);

      if(key_of("order",key_of("data",$kit["kit_option"])) == "descending")
        $array["data"] = array_reverse($array["data"]);

			/*
			if($limit = key_of("limit",key_of("data",$kit["kit_option"]))) {
				if (is_indexed($limit) && count($limit) == 2)
					$array["data"] = array_slice($array["data"],$limit[0],$limit[1],true);
				else
	      	$array["data"] = array_slice($array["data"],0,int($limit),true);
			}
			*/
      reset($array);

      break;

  default:

    $array = $data->read();
}

// Restore filter

$data->filter(false);
$data->filter($filter_backup);
