<?php

/*---------------- REMARKS ----------------*\

This file is included before the rendering of
the overview occurs. It has access to the
objects $core, $kit, $data, $table and
$additional_menu. Changes to
these objects will get returned.

\*----------------------------------------*/

$return_edit = $table->config("edit");


$return_filealias = function ($filealias, $group_ID) use($core) {

  $path = $core->content->group->structure_ID_to_path('ID='.$group_ID.',path=full');

  return '<a href="'.$path.$filealias.'" target="_blank" title="'.$path.$filealias.'">'.$filealias.'</a>';
};


$return_is_file = function ($is_file, $filename, $ID) use ($core) {

  $status = array("Database","File");
	$is_file = either($is_file,"0");

  if (is_empty($filename))
    // return $status[0];
    return "";

	$content = $core->filesystem($core->path("content"));

  if (!$content->file->exists($ID."/".$filename)){
		// Backwards Compatibility
		if ($content->file->exists($filename)){
			$content->file->move($filename,$ID."/".$filename);
		}
		// Else fail
		else{
    	// return $status[0];
    	return "";
		}
	}

	return $core->html->render(
		$core->html->tag("a",
			array(
				$core->template->icon("switch"),
				$core->html->tag("span",$label = $core->language->translate($status[$is_file]))
			),
			array(
				"href" => $core->url(["do" => "storage", "ID" => $ID]),
				"class" => "small button",
				"title" => "Switch output for content",
				"style" => "display: block; text-align: left"
			)
		)
	);
};


$return_secure = function ($secure, $ID) use($core) {

	$secure = (bool) $secure;

	return $core->template->kit->small_button(
		ifttt($secure, "locked", "unlocked"),
		"",
		[
			"class" => ifttt($secure, "red", "green"),
			"title" => $core->language->translate(ifttt(
				$secure,
				"Content is locked. Toggle to turn content public",
				"Content is public. Toggle to turn content locked"
			)),
			"href" => $core->url(["do"=>"secure","ID"=>$ID]),

		]
	);

};


$return_defaultpath = function ($defaultpath, $ID) use($core) {

	if (are_equal($defaultpath, 0))
		return $core->template->kit->small_button("structure","",[
			"href" => $core->url(["do" => "set_default_structure", "ID" => $ID]),
			"title" => $core->language->translate("Use this structure only with direct call"),
			"class" => "small"
		]);

	return $core->template->kit->small_button("structure_active","",[
		"href" => $core->url(["do" => "set_default_structure", "ID" => $ID]),
		"title" => $core->language->translate("Use this structure even without call"),
		"class" => "small active"
	]);


};


$return_is_base_dir = function ($is_base_dir, $ID) use ($core) {

	if (are_equal($is_base_dir, 0))
		return $core->template->kit->small_button("connected","",[
			"href" => $core->url(["do" => "set_base_dir", "ID" => $ID]),
			"title" => $core->language->translate("Link outside this structure is possible"),
			"class" => "small"
		]);

	return $core->template->kit->small_button("unconnected","",[
		"href" => $core->url(["do" => "set_base_dir", "ID" => $ID]),
		"title" => $core->language->translate("Link outside this structure is not possible"),
		"class" => "small active"
	]);

};


$return_content_group_name = function ($name, $ID) use ($core,$data, $return_edit){

  // $link = $return_edit($ID,$name);
	$link = $name;

  if ($data->count_per("group_ID", $ID))
    return $core->template->icon("folder_document").$link;

  return $core->template->icon("folder").$link;
};


$return_status = function ($defaultpath = "", $is_base_dir = "", $ID = "") use($core, $return_defaultpath, $return_is_base_dir) {

	return $core->html->div([
		$return_defaultpath($defaultpath, $ID),
		$return_is_base_dir($is_base_dir, $ID),
	],[

	]);

};

$table->config([
	"return_filealias" => $return_filealias,
	"return_is_file" => $return_is_file,
	"return_secure" => $return_secure,
	"return_defaultpath" => $return_defaultpath,
	"return_is_base_dir" => $return_is_base_dir,
	"return_status" => $return_status,
	"return_content_group_name" => $return_content_group_name,
]);

if (!are_equal($core->session->kit->get("more_columns"),1))
	$table->remove_column(["is_file","filename"]);

if (is_empty($core->get("view")))
	$additional_menu[0][] = $core->template->kit->button(
		"more_columns","",
		[
			"href"=>$core->url(["do"=>"toggle_more_columns"]),
			"class" => iftctt($core->session->kit->get("more_columns"), 1, "active")
		]
	);