<?php
$ID = $core->get("ID");
$entry = [];
$group_ID = false;

$object->reset("foreign");

if ($ID) {

	$entry = $object->entry($ID);

	if (not_empty($entry))
		$group_ID = key_of("group_ID", $entry);

	else
		$ID = false;
}

if (!$view_groups) {

	$set_group_ID = key_of($data->group(), $core->session->kit->get("filter"));

	if (!$group_ID)
		$group_ID = $set_group_ID;
}

else {
	$group_ID = $core->get("ID");
	$set_group_ID = false;
}

if (is_object($data->group))
  $parent_group_IDs = $data->group->read_parents($group_ID);

$layout = $get_config("edit_layout");

$properties = $get_config("edit_properties");

$form = $core->form();

$core_tables_o = $core->data("kb_tables");

if (not_empty($fields = $object->db_column_options()) && is_empty($properties)) {

	$types = array(
		"varchar" => "textarea",
		"datetime" => "datetime-local",
		"timestamp" => "datetime-local",
		"tinyint(1)" => "select",
	);

	if (is_indexed($fields)) {
		foreach ($fields as $column) {
			$form->new_element(
				$column, array(
					// "type" => fetch($type,$types),
					"value" => key_of($column,$entry),
					"label" => ucfirst($column),
				)
			);
		}
	}

	else {
		foreach($fields as $column => $type){
			$form->new_element(
				$column, array(
					"type" => fetch($type,$types),
					"value" => key_of($column,$entry),
				)
			);
		}
	}
}

if (is_object($data->group) && !$view_groups && !array_find(array("type"=>"group_ID"),$properties)) {

	$value = "";

	if ($set_group_ID)
		$value = $set_group_ID;

	if ($ID)
		$value = $entry["group_ID"];

	if (!isset($form->element["group_ID"]))
		$form->new_element(
			"group_ID", array(
				"label"	=> "Group",
				"type"	=> "select",
				"value"	=> $value,
				"values"	=> $data->group->read_column("name", array("default"=>$core->language->translate("none"))),
				// "values"	=> $data->group->read_dropdown($core->language->translate("none")),
			)
		);
}

if (is_object($data->group) && $data->group->group && $view_groups)
	if(!isset($form->element["parent_ID"]))
		$form->new_element(
			"parent_ID", [
				"label"	=> "Parent Group",
				"type"	=> "select",
        "value"	=> key_of("parent_ID",$entry),
				"values" => $data->group->select_parent($ID, ["default" => ["NULL" => $core->language->translate("none")]]),
      ]
		);

if ($object->position)
  $form->new_element(
  	"position", array(
  		"label"		=> "Position",
  		"type"		=> "select",
			"translate" => true,
  		"values"	=> $object->dropdown_position($ID),
  	)
  );

if (not_empty($properties)) {

	foreach ($properties as $key => &$property) {

		$key = (is_numeric($key) && isset($property["key"])) ? $property["key"] : $key;
		$class = key_fetch("class",fetch(array("type"=>key_fetch("type",$property)),$input_types));
		$markup = key_of("markup", $property);

		if ($class)
			$markup = $core->html->add_class($markup,$class);

		$markup = $core->html->property($markup,"data-field",$key);
		$markup = $core->html->add_class($markup,key_of("class",$property));
		$markup = $core->html->property($markup,"style",key_of("style",$property));

		$continue = false;

		if (!isset($form->element[$key]))
	    $form->new_element($key);

		else
			$continue = true;

		$form->set_element($key, array(
			"label" => either(key_fetch("label",$property), $key),
			"markup" => $markup,
			"disabled" => either(ifttt(($core->get_var("do") == "view"), true), false),
		));


		// Ignore rest for form fields set by kit
		// if($continue)
			// continue;

		$value = either(key_of("value", $property), key_of($key, $core->session->kit->get("filter")), "");

		if ($ID && isset($entry[$key])) {
			if (!fetch(key_of("type", $property), array("json","code")))
				if (is_array($array = $core->json->decode($entry[$key])))
			  	$entry[$key] = $array;

			$value = $entry[$key];
		}

		$form->element[$key]["value"] = $value;

		if (not_empty(key_of("options", $property)))
			foreach ($property["options"] as $option) {

				if (is_array($option))
					$form->element[$key][key($option)] = current($option);

				else
					$form->element[$key][$option] = true;

				if (are_equal($option, "array") && !is_array($form->element[$key]["value"]))
					$form->element[$key]["value"] = array($value);
			}

		if (not_empty(key_of("type",$property))) {

			$form->element[$key]["type"] = either(
				key_fetch("field",fetch(array("type"=>$property["type"]),$input_types)),
				key_fetch("type",fetch(array("type"=>$property["type"]),$input_types))
			);

			if (($property["type"] == "select" || $property["type"] == "radio" || $property["type"] == "checkbox") && !empty($property["values"])) {
				$form->element[$key]["values"] = $property["values"];
				$form->element[$key]["translate"] = true;
			}

			if ($property["type"] == "date" && !empty($property["values"])) {

				unset($value);

				if (is_array($form->element[$key]["value"])) {

					foreach ($form->element[$key]["value"] as $temp_value)

					if (!empty($temp_value))
						$value[] = date("Y-m-d",strtotime($temp_value));

					else if (!empty($property["values"]))
						$value[] = date("Y-m-d",strtotime($property["values"]));

				}

				else {

					if (!empty($form->element[$key]["value"]))
						$value = date("Y-m-d",strtotime($form->element[$key]["value"]));

					else if (!empty($property["values"]))
						$value = date("Y-m-d",strtotime($property["values"]));
				}

				$form->element[$key]["value"] = $value;
			}

			else if ($property["type"] == "number") {

				if (not_empty($precision = key_of("values", $property))) {
					if (are_equal($precision,0))
						$step = "1";
					else if (are_equal($precision,1))
						$step = "0.1";
					else
						$step = "0.".str_repeat("0", $precision-1)."1";

					$form->element[$key]["markup"] .= ' step="'.$step.'"';
				}


			}

			else if ($property["type"] == "image") {

				// Turn old into new file format
				if (not_empty($file_paths = key_fetch("path", $entry[$key])))
					$entry[$key] = $file_paths;

			}

			else if ($property["type"] == "datetime-local") {

				$value = NULL;

				if (is_array($form->element[$key]["value"])) {

					foreach ($form->element[$key]["value"] as $temp_value)
						if(not_empty($temp_value))
							$value[] = date("Y-m-d\TH:i",strtotime($temp_value));
						else if (!empty($property["values"]))
							$value[] = date("Y-m-d\TH:i",strtotime($property["values"]));

				}

				else {

					if (!empty($form->element[$key]["value"]))
						$value = date("Y-m-d\TH:i",strtotime($form->element[$key]["value"]));

					else if (!empty($property["values"]))
						$value = date("Y-m-d\TH:i",strtotime($property["values"]));
				}

				$form->element[$key]["value"] = $value;
				$form->element[$key]["markup"] .= ' step="60"';
			}

			else if ($property["type"] == "foreign") {

				$form->element[$key]["type"] = "select";

				if (is_array(key_of("values",$property)) && not_empty($property["values"][0])) {

					if (!preg_match("/_group/",$property["values"][0])) {

						$table_o = $core->data_o($property["values"][0]);

						if ($core->db->table_exists($property["values"][0]."_group")) {
							$table_o->group(true);
							$table_o->group->order("name");
						}
					}
					else {
						$table_o = $core->data_group_o($property["values"][0]);

						if (not_empty($column = key_of(1,$property["values"])))
							$table_o->order($column);
					}

				}

				if (isset($property["filter"]) && not_empty($property["values"][1])) {

					if (preg_match("/_group/",$property["values"][0])) {

						if (key($property["filter"]) == "children")
							$table_o->filter("parent_ID", current($property["filter"]));
						else
							$table_o->filter("ID", $table_o->read_children(current($property["filter"])));
					}

					else {

						if (key($property["filter"]) == "descendant") {

							if ($table_o->group) {
								$IDs = $table_o->group->read_children(current($property["filter"]));
								$IDs = array_merge(
									array(current($property["filter"])),
									$IDs
								);
								$table_o->filter(array("group_ID"=>$IDs));
							}

							else {
								$IDs = $table_o->read_children(current($property["filter"]));
								$IDs = array_merge(
									array(current($property["filter"])),
									$IDs
								);
								$table_o->filter(array("ID" => $IDs));
							}
						}

						else if (key($property["filter"]) == "children") {

							$table_o->filter(array("group_ID" => current($property["filter"])));

						}
					}
				}

				if (is_array(fetch("values",$property)) && not_empty($property["values"][1])) {

					$table_o->order($property["values"][1]);

					$form->element[$key]["values"] = $table_o->read_column($property["values"][1],array(
						"default" => " ",
						"group" => $table_o->group,
						"spacing" => "&nbsp;&nbsp;&nbsp;",
						"ID"			=> not_empty(key_of("filter",$property)) ? current($property["filter"]) : "",
					));

				}
			}

			else if (fetch("correlation", $property["type"])) {

				if (any_empty($property["values"] = key_of("values", $property), key_of(0, $property["values"]), key_of(1, $property["values"])))
					continue;

				$form->element[$key]["type"] = either(key_fetch("correlation",$property["type"]),"checkbox");

				$cID = $object->correlates($ID,$property["values"][0]);

				$property["correlation_ID"] = key_of($property["values"][0], $data->tables());

				if (preg_match("/_group/",$property["values"][0]))
					$table_o = $core->data_group_o($property["values"][0]);

				else
					$table_o = $core->data_o($property["values"][0]);

				if (not_empty($property["values"][1]))
					$table_o->order($property["values"][1]);

				if (isset($property["filter"])) {

					if (preg_match("/_group/",$property["values"][0])) {

						if (key($property["filter"]) == "children") {
							$table_o->filter(array("parent_ID" => current($property["filter"])));
						}

						else if(key($property["filter"]) == "descendant") {
							$IDs = $table_o->read_children(current($property["filter"]));
							$IDs = array_merge(
								array(current($property["filter"])),
								$IDs
							);
							$table_o->filter(array("parent_ID" => $IDs));
						}
					}

					else {

						if (key($property["filter"]) == "children") {
							$table_o->filter(array("group_ID" => current($property["filter"])));
						}

						else if(key($property["filter"]) == "descendant") {
							$table_o->group(true);
							$IDs = $table_o->group->read_children(current($property["filter"]));
							$IDs = array_merge(
								array(current($property["filter"])),
								$IDs
							);
							$table_o->filter(array("group_ID" => $IDs));
						}
					}
				}

				$form->element[$key]["value"] = $cID;
				$form->element[$key]["values"] = $table_o->read_column($property["values"][1],array(
					"spacing" => "&nbsp;&nbsp;&nbsp;",
					"ID"	=> !empty($property["filter"]) ? current($property["filter"]) : ""
					)
				);
			}

			else if ($property["type"] == "group_ID") {

				$form->element[$key]["type"] = "select";
				// $form->element[$key]["values"]	= $data->group->read_dropdown(array("NULL"=>$core->language->translate("none")));
				$form->element[$key]["values"]	= $data->group->read_column("name", array("default"=>$core->language->translate("none")));

				if ($set_group_ID)
					$form->element[$key]["value"]	= $set_group_ID;

				if ($ID)
					$form->element[$key]["value"]	= $entry[$property["key"]];

			}

			else if ($property["type"] == "parent_ID") {

				$form->element[$key]["type"] = "select";

				$form->element[$key]["value"]	= key_of("parent_ID",$entry);
				$form->element[$key]["values"] = $data->group->select_parent(
					$ID,
					array(
						"default"=>array("NULL"=>$core->language->translate("none")),
					)
				);

			}

			else if ($property["type"] == "position") {

				$form->set_element($key, array(
					"type" => "select",
					"value"	=> "",
				));

			}
		}
	}
	unset($property);
}

$form->new_element(
	"submit", array(
		"type"		=> "submit",
		"label"		=> "Save",
		"class"	=> "green",
	)
);


$edit_before_check();

// Reload ID after it may has been set by edit_before_check()
$ID = $core->get_var("ID");


if ($form->check() && $user_can("edit")) {

	$values = $form->values();

	// Extract correlation

	$correlation_properties = fetch(array("type"=>"correlation"), $properties);
	$correlation_data = keys_of(key_fetch("key",$correlation_properties),$values);
	$values = $core->array->diff($values,$correlation_data);


	// Prepare Files

	$core->filesystem->base_dir($core->path("files"));

	$file_properties = fetch(array("type"=>array("file","image", "video")), $properties);

	if (not_empty(key_fetch("key",$file_properties))) {

		foreach ((array)key_fetch("key",$file_properties) as $key) {

			if (is_indexed(key_of($key, $values))) {
				foreach(key_of($key, $values) as $index => $value)
					if (not_empty($value))
						// $values[$key][$index] = $core->json->decode($value);
						// Turn old into new file format
						$values[$key][$index] = either(key_of("path", $value), $value);
					else
						unset($values[$key][$index]);

				// Reindex array;
				$values[$key] = array_values($values[$key]);
			}
			else if (not_empty(key_of($key, $values))) {
				// $values[$key] = $core->json->decode($values[$key]);
				// Turn old into new file format
				$values[$key] = either(key_of("path", $values[$key]), $values[$key]);
			}
		}
	}

	// Create entry

	if (!$ID) {

		// Import default values
		$create = $core->kit->load($core->kit->id,"create");

		$create = $core->array->merge(
			$create,
			$values
		);

		$core->message->set(
			$ID = $object->create($create),
			"Create entry"
		);

		$core->message->info("Entry created successfully ","There was an error creating the entry");

	}


	// Update entry

	else {

		$update = array(
			"ID" => $ID,
		);

		$update = $core->array->merge(
			$update,
			$values
		);

		$object->update($update);

		$core->message->info("Entry updated successfully","There was an error updating the entry");
	}


	// Set correlation

	if (not_empty($correlation_properties)) {

		foreach ($correlation_properties as $correlation_property) {

			$object->correlates(
				$ID,
				key_of("correlation_ID",$correlation_property),
				key_of(key_of("key",$correlation_property),$correlation_data)
			);

		}

	}


	// Files
	// Delete

	foreach ((array) key_fetch("key",$file_properties) as $key) {

		$delete = $core->array->diff(
			(array) key_of($key, $entry),
			(array) key_of($key,$values)
		);

		// $delete = key_fetch("path",$delete);

		$core->filesystem->delete(
			$core->filesystem->search($delete, ".cache")
		);

		$core->filesystem->delete($delete);

	}

	// Add

	if (not_empty($form->files())) {

		$update = [];

		foreach($form->files() as $key => $files) {

			$file_property = fetch(array("key"=>$key),$file_properties);
			$options = key_fetch("options",$file_property);

			if (is_indexed($files)) {

				$update[$key] = either(key_of($key, $values), []);

				foreach ($files as $file) {

					if ($file["error"])
						continue;

					$target = "/".$kit["config"]["unique_name"]."/$ID/".$file["name"];

					$core->filesystem->move($file['tmp_name'],$target);

					if (fetch("6mp",$options))
						downsample($target,3000);

					if (is_empty(fetch($file["name"],key_of($key, $entry))))
						$update[$key][] = $target;
				}

			}

			else {

				if ($files["error"])
					continue;

				$target = "/".$kit["config"]["unique_name"]."/$ID/".$files["name"];

				$core->filesystem->move($files['tmp_name'],$target);

				if (fetch("6mp",$options))
					downsample($target,3000);

				$update[$key] = $target;
			}

		}

		if (not_empty($update))
			$object->update($update, ["ID"=>$ID]);

	}

	$core->refresh(["ID"=>$ID]);
}

$table_1col = $core->view->table();
$table_2col = $core->view->table();

$table_1col->config("style_classes", array("table"=>"form"));
$table_2col->config("style_classes", array("table"=>"form"));

$table_1col->new_column("field",array(
	"title" => "",
	"search" => false,
	"sort" => false,
));

$table_2col->new_column("label",array(
	"title" => "",
	"search" => false,
	"sort" => false,
));

$table_2col->new_column("field",array(
	"title" => "",
	"search" => false,
	"sort" => false,
));



$output = "";
$statistic = "";
$versions = "";

if ($object->statistic && key_fetch("created", $entry)) {

	if (key_of("created", $entry))
		$statistic = $core->html->article([
			$core->html->p([
				$core->language->translate("Created").": ",
				kb_date("H:i d.m.Y",key_of("created", $entry))." ",
				$core->language->translate("by").": ",
				$core->user->data("name",key_of("created_by", $entry)),
			],["class" => "light"]),
			$core->html->p([
				$core->language->translate("Updated").": ",
				kb_date("H:i d.m.Y",key_of("updated", $entry))." ",
				$core->language->translate("by").": ",
				$core->user->data("name",key_of("updated_by", $entry)),
			],["class" => "light"]),
		]);
}

if ($ID && $object->versions()) {
	$versions = $object->versions($ID);
	$versions_table = $core->view->table();
	$versions_table->new_columns([
		"remarks" => [
			"title" => "Remarks",
			"value" => 'translate_value($remarks)'
		],
		"datetime" => [
			"title" => "Date",
			"format" => "datetime",
		],
		"ID" => [
			"title" => "",
			"value" => 'restore_version($ID)'
		],
	]);

	$restore_version = function ($ID) use ($core) {
		return $core->template->kit->small_button("Restore", ["href"=>$core->url(["do"=>"restore_version","version"=>$ID])]);
	};

	$translate_value = function ($string) use ($core) {
		return $core->language->translate($string);
	};

	$versions_table->config("restore_version",$restore_version);
	$versions_table->config("translate_value",$translate_value);
	$versions = $versions_table->render($versions);
}

if (not_empty($layout)) {

	$render_tab = function ($layout_array) use ($core, $form, $properties, $table_1col, $table_2col) {

		$output = "";

		foreach ($layout_array as $row_nr => $row) {

			static $groups_counter = 0;
			$groups_counter++;
			// $output .= '<div style="display: table; width: 100%">';

			//Check for Multi Row
			$bool = false;
			foreach ($row as $column_nr => $column) {
				if(isset($column["options"]) && in_array("array",$column["options"]))
				$bool = true;
				else false;
			}

			$j_count = 1;

			if($bool){
				$field_ID = current($column["fields"]);
				$field_key = $properties[$field_ID]["key"];
				$j_count = count($form->element[$field_key]["value"]);
			}

			for($j=0;$j<$j_count;$j++) {

				//Reset Values
				if ($j_count > 1)

				foreach ($row as $column_nr => $column) {

					foreach ($column["fields"] as $key => $value) {

						if(isset($properties[$value]["type"]) && in_array($properties[$value]["type"],array("foreign","correlation")))
							$value = (is_numeric($value) && isset($properties[$value]["key"])) ? $properties[$value]["values"]."__".$properties[$value]["key"] : $value;
						else
							$value = (is_numeric($value) && isset($properties[$value]["key"])) ? $properties[$value]["key"] : $value;

						if(!isset($static_values[$value]))
							$static_values[$value] = $form->element[$value]["value"];

						$form->element[$value]["value"] = array(current($static_values[$value]));
						next($static_values[$value]);
					}
				}

				$output .= '<div class="table data no_margin" data-field_groups="'.$groups_counter."_".$j.'">';

				foreach ($row as $column_nr => $column) {

					$array = array();

					//Check for Multi Column
					if (not_empty(key_of("fields", $column))) {

						$i_count = 1;

						if (isset($column["options"]) && in_array("array",$column["options"])){
							$field_ID = current($column["fields"]);
							$field_key = $properties[$field_ID]["key"];
							$i_count = count($form->element[$field_key]["value"]);
						}

						for ($i = 0;$i < $i_count; $i++) {

							$array = array();

							foreach ($column["fields"] as $key => $value) {

								$value = (is_numeric($value) && isset($properties[$value]["key"])) ? $properties[$value]["key"] : $value;

								if ($i_count > 1) {

									if (!isset($static_values[$value]))
										$static_values[$value] = $form->element[$value]["value"];

									$form->element[$value]["value"] = array(current($static_values[$value]));
									next($static_values[$value]);
								}

								if (
									not_empty($label = $form->label($value)) &&
									not_empty($field = $form->field($value))
								)
									$array[] = array(
										"label"	=> $label,
										"field"	=> $field,
									);

								if (
										($j_count > 1 && $j+1 == $j_count) ||
										(
											($j_count == 1 && $i_count > 1 && $i+1 == $i_count) ||
											($j_count == 1 && $i_count == 1)
										)
									)
									unset($form->element[$value]);
							}

							if (fetch("field",$array)) {

								if (count($row) > 1){
									$width = 100/count($row);
									$output .= '<div style="display: table-cell;" ';

									if (isset($column["options"]) && in_array("array",$column["options"])) {
										static $group_counter = 1;
										$output .= 'data-field_group="'.$group_counter++.'" ';
									}
									else {
										$output .= 'data-field_group="" ';
									}

									$output .= '>';

								}
								else{
									$output .= '<div>';
								}


								$h3_content = array($core->language->translate(key_of("label",$column)));

								if (isset($column["options"]) && in_array("array",$column["options"]))
									$h3_content[] = ' <a class="small button" data-duplicate_field_group="'.$i.'"><strong>[ + ]</strong></a>';

								if (not_empty($h3_content))
									$output .= $core->html->article($core->html->h3($h3_content));

								if (count($array) == 1)
									$output .= $table_1col->render($array);
								else
									$output .= $table_2col->render($array);

								$output .= "</div>";
							}
						}
					}
				}
				$output .= "</div>";
			}
		}
		return $output;
	};

	if (is_indexed($layout)) {
		$output .= $render_tab($layout);
		$output .= $statistic;
	}

	else {

		foreach ($layout as $tab => $tab_content)
			$tabs[$core->language->translate($tab)] = $render_tab($tab_content);

		if (not_empty($statistic))
			$tabs["About"] = $statistic;

		if (not_empty($versions))
			$tabs["Versions"] = $versions;

		$output .= $core->template->kit->tabs($tabs);
	}
}



if ($ID) {
	$core->template->kit->panel->title($core->language->translate("Edit"));
	$core->template->kit->panel->title("<span style=\"float: left; font-size: 1rem\">ID: $ID</span>");
}

else {
	$core->template->kit->panel->title("Add Entry");
}

$table_menu = array();

if ($user_can("edit_properties")) {
	$table_menu["edit_properties"] = array(
		"title" => "Data Entry Fields",
		"class" => "small button"
	);
}


if (not_empty($table_menu)) {
	$table_menu = $core->template->kit->table_menu($table_menu);
	$table_menu = $core->html->add_class($table_menu,"section");
	$core->template->kit->panel->body($table_menu);
}

$core->template->kit->panel->body($output);

$core->template->kit->panel->body($form->render(false));

$core->template->kit->panel->footer(ifttt($user_can("edit"),$form->field("submit")));
$core->template->kit->panel->footer(
	$core->template->kit->button("Close",["class"=>"cancel button","href"=>$core->url(["do"=>"","ID"=>""])])
);

$core->template->kit->panel->options(["footer"=>["class"=>"fill flex"]]);

echo $core->html->render(
	$core->html->tag(
		"form",
		[$core->template->kit->panel()],
		[
			"enctype" => "multipart/form-data",
			"method" => "post",
			"accept-charset" => "utf-8",
		]
	)
);
