<?php

$mixed = key_of("mixed",$kit["kit_option"]);

$replace = function($entry, $option) use (&$replace, $parse_function, $core, $return_function, $return_markdown, $return_file, $return_text, $return_link) {

	$mixed = key_of("mixed",$option);
	$columns = either(key_of("columns",$option), []);

	$needle = array();
	$replacement = array();

	if(is_indexed($columns))
		$columns = array_combine($columns,$columns);

	foreach($columns as $column => $config){

		$needle[] = preg_mod('\$'.$column);

		$column = either(key_of("key",$config), $column);

		if(($correlation = key_of("correlation",$option)) && array_key_exists($column,$correlation)){

			$sub_replacement = array();
			foreach(fetch(fetch($column,$correlation),$entry) as $sub_entry){
				$sub_replacement[] = $replace(
					$sub_entry,
					$config
				);
			}

			$replacement[] = implode($sub_replacement);

			continue;
		}

		else if(
			(($foreign = key_of("foreign",$option)) && array_key_exists($column,$foreign)) ||
			(key_of("columns",$config))
		) {

			array_pop($needle);

			foreach ((array) key_of("columns",key_of($column,$columns)) as $key => $value) {

				if (key_of("columns", $value)) {

					foreach (key_of("columns", $value) as $sub_key => $sub_value) {

						if (is_string($sub_value))
							$sub_value = array("output"=>$sub_value);

						$sub_column = array($column=>array($key=>$sub_key));
						$needle[] = preg_mod('\$'.$column.'->'.$key.'->'.$sub_key);

						if (key_of("output",$sub_value) == "function")
							// $replacement[] = call_user_func("return_function",$entry, $sub_column, key_of("function",$sub_value));
							$replacement[] = $return_function($entry, $sub_column, key_of("function",$sub_value));

						else if (key_of("output",$sub_value) == "file")
							// $replacement[] = call_user_func("return_file",$entry, $sub_column,  key_of("file",$sub_value));
							$replacement[] = $return_file($entry, $sub_column,  key_of("file",$sub_value));

						else if (key_of("output",$sub_value) == "markdown")
							$replacement[] = call_user_func($return_markdown,$entry, $sub_column, $sub_value);

						else if (key_of("output",$sub_value) == "mixed")
							$replacement[] = ifttt(
								fetch($sub_column,$entry),
								$replace($entry, array(
									"mixed" => key_of("mixed", $config),
									"columns" => array($column=>array($key=>""))
								)),
								""
							);

						else
							// $replacement[] = call_user_func("return_text",$entry,$sub_column, $sub_value);
							$replacement[] = $return_text($entry,$sub_column, $sub_value);

					}

				}

				else {

					$sub_column = array($column=>$key);
					$needle[] = preg_mod('\$'.$column.'->'.$key);

					if (($sub_select = key_of("sub_select",$value)) !== NULL){
						$sub_column = array($column=>array($key=>$sub_select));
					}

					if (key_of("output",$value) == "function")
						// $replacement[] = call_user_func("return_function",$entry, $sub_column, key_of("function",$value));
						$replacement[] = $return_function($entry, $sub_column, key_of("function",$value));

					else if (key_of("output",$value) == "file")
						// $replacement[] = call_user_func("return_file",$entry, $sub_column, key_of("file",$value));
						$replacement[] = $return_file($entry, $sub_column, key_of("file",$value));

					else if (key_of("output",$value) == "markdown")
						// $replacement[] = call_user_func("return_markdown",$entry, $sub_column, $value);
						$replacement[] = $return_markdown($entry, $sub_column, $value);

					else if (key_of("output",$value) == "mixed") //{
						$replacement[] = ifttt(
							fetch($sub_column,$entry),
							$replace($entry, array(
								"mixed" => key_of("mixed", $config),
								"columns" => array($column=>array($key=>""))
							)),
							""
						);
						/*
						if (fetch($sub_column,$entry))
							$replacement[] =  $replace($entry, array(
								"mixed" => key_of("mixed", $config),
								"columns" => array($column=>array($key=>""))
							));
						else
							$replacement[] = "";
						*/
					// }

					else
						// $replacement[] = call_user_func("return_text",$entry,$sub_column, $value);
						$replacement[] = $return_text($entry,$sub_column, $value);
				}

			}

			unset($entry[$column]);
			continue;
		}

		else if (($sub_select = key_of("sub_select",$config)) !== NULL){
			$column = array($column=>$sub_select);
		}

		if (key_of("output",$config) == "function")
			// $new_replacement = call_user_func("return_function",$entry,$column, key_of("function",$config));
			$new_replacement = $return_function($entry,$column, key_of("function",$config));

		else if (key_of("output", $config) == "file")
			// $new_replacement = call_user_func("return_file",$entry,$column, key_of("file",$config));
			$new_replacement = $return_file($entry,$column, key_of("file",$config));

		else if (key_of("output", $config) == "markdown")
			// $new_replacement = call_user_func($return_markdown,$entry,$column, key_of("markdown", $config));
			$new_replacement = $return_markdown($entry,$column, key_of("markdown", $config));

		else if (key_of("output", $config) == "mixed") {
			if (key_of($column,$entry))
				$new_replacement =  $replace($entry, array(
					"mixed" => key_of("mixed", $config),
					"columns" => array($column=>"")
				));
			else
				$new_replacement = "";
		}

		else
			// $new_replacement = call_user_func("return_text",$entry,$column, $config);
			$new_replacement = $return_text($entry,$column, $config);

		if(is_array($new_replacement))
			$new_replacement = $core->array->implode($new_replacement);

		$replacement[] = $new_replacement;

	}
	$html = $core->html->render($mixed);

	foreach ($replacement as $key => $value)
		$replacement[$key] = preg_replace(array("/\(/","/\)/","/,/"),array("&#40;","&#41;","&#44;"),$value);

	$html = preg_replace($needle,$replacement,$html);
	$html = $parse_function($html);

	return $html;

};

if (not_empty($array)) {

	if (!is_array(current($array)))
		$array = array($array);

	// Select data or
	// Select groups
	if (!isset($array["data"])) {

		// $columns = fetch("columns",$kit["kit_option"]);

		if ($pagination = key_of("pagination",$kit["kit_option"])) {
			$pagination_o = $core->pagination();
			$array = $pagination_o->set($array,$pagination);
		}

		foreach ($array as $entry)
			echo $replace($entry, $kit["kit_option"]);

		if ($pagination)
			echo $pagination_o->render(either(key_of("pagination_options",$kit["kit_option"]),[]));

	}

	// Select data_and_groups with separated statements for mixed content
	else if (key_of("mixed",key_of("data",$kit["kit_option"]))) {

		$config["groups"] = key_of("groups",$kit["kit_option"]);
		$config["data"] = key_of("data",$kit["kit_option"]);

		if ($columns = key_of("columns",$config["groups"])) {

			// $config["data"]["columns"] = array("group"=>array())+$config["data"]["columns"];
			$config["data"]["columns"]["group"] = array();

			foreach ($columns as $column => $value)
				$config["data"]["columns"]["group"]["columns"][$column] = $value;

		}
		$array["data"] = $core->array->group_by($array["data"],"group_ID");

		if ($limit = key_of("limit",key_of("data",$kit["kit_option"]))) {

			foreach ($array["data"] as $group_ID => $entries) {

				if (is_indexed($limit) && count($limit) == 2)
					$array["data"][$group_ID] = array_slice($entries,$limit[0],$limit[1],true);
				else
					$array["data"][$group_ID] = array_slice($entries,0,int($limit),true);
			}
		}

		foreach ($array["groups"] as $entry["groups"]) {

			$group_ID = key_of("ID", $entry["groups"]);

			$html_group = $replace(
				$entry["groups"],
				$config["groups"]
			);

			$html_data = array();

			foreach((array) key_of($group_ID, $array["data"]) as $entry["data"]){

				$entry["data"]["group"] = $entry["groups"];
				$html_data[] = $replace($entry["data"],$config["data"]);

			}

			/*
			foreach($array["data"] as $entry["data"]){

				if($group_ID != $entry["data"]["group_ID"])
					continue;

				$entry["data"]["group"] = $entry["groups"];
				$html_data[] = $replace($entry["data"],$config["data"]);

			}
			*/
			// if($html_group){
				$html_data = implode($html_data);
				$html = preg_replace('/\$data/',$html_data,$html_group,-1,$count);
				if($count){
					echo $html;
				}
				else{
					echo $html_group;
					echo $html_data;
				}
			// }
		}
	}

	// Select data_and_groups with combined mixed content
	else{

		$columns["groups"] = key_of("columns",key_of("groups",$kit["kit_option"]));
		$columns["data"] = key_of("columns",key_of("data",$kit["kit_option"]));

		foreach($array as $data_or_groups => $sub_array){

			if ($run = key_of("run", key_of($data_or_groups, $kit["option"]))) {

				foreach ($run as $column => $run_options) {
					$needle[] = preg_mod('\$'.$data_or_groups.'->\$'.$column);
					$replacement = $core->kit->run($core->kit->current["unique_name"],$run_options);
				}

				$mixed = $core->html->render($mixed);
				$mixed = preg_replace($needle,$replacement,$mixed);

			}

			if($limit = key_of("limit",key_of($data_or_groups,$kit["kit_option"]))) {

				if (is_indexed($limit) && count($limit) == 2)
					$sub_array = array_slice($sub_array,$limit[0],$limit[1],true);
				else
					$sub_array = array_slice($sub_array,0,int($limit),true);

			}

			if(isset($columns[$data_or_groups]))
			foreach($sub_array as $entry){

				$needle = array();
				$replacement = array();

				if (!empty($columns[$data_or_groups]))
				foreach ($columns[$data_or_groups] as $column => $config) {

					$needle[] = preg_mod('\$'.$data_or_groups.'->\$'.$column);

					if (($sub_select = key_of("sub_select",$config)) !== NULL)
						$column = array($column=>$sub_select);

					if ($config["output"] == "function")
						// $replacement[] = call_user_func("return_function",$entry,$column, fetch("function",$config));
						$replacement[] = $return_function($entry,$column, fetch("function",$config));

					else if ($config["output"] == "file")
						// $replacement[] = call_user_func("return_file",$entry,$column, $config);
						$replacement[] = $return_file($entry,$column, $config);

					else if ($config["output"] == "markdown")
						$replacement[] = $return_markdown($entry,$column, $config);

					else
						$replacement[] = $return_text($entry,$column, $config);
				}

				$html = $core->html->render($mixed);

				foreach ($replacement as $key => $value)
					$replacement[$key] = preg_replace(array("/\(/","/\)/","/,/"),array("&#40;","&#41;","&#44;"),$value);

				$html = preg_replace($needle,$replacement,$html,-1,$count);
				$html = $parse_function($html);

				if($count)
					echo $html;
			}
		}
	}
}

else if(!empty($on_empty)){

	echo $core->kit->run(either(key_of("source",$on_empty),$kit["config"]["unique_name"]),$on_empty);

}