<?php
$entry_fields = $get_config("edit_properties");
$properties = $get_config("overview_properties");

if (is_empty($entry_fields) && is_array($object->auto_create)) {

		foreach ($object->auto_create as $key => $value) {

			if (is_numeric($key))
				$key = $value;

			$entry_fields[] = array(
				"label" => $key,
				"key" => $key,
				"type" => "text",
			);
		}
}

$form = $core->form();
$form1_count = 0;

if (not_empty($entry_fields)) {

	foreach ($entry_fields as $key => $value) {

		$isset = false;
		$p_key = false;

		if (not_empty($properties))

			foreach ($properties as $p_key => $p_value) {

				if ($core->array->match(
					keys_of(["label","key","type"], $p_value),
					keys_of(["label","key","type"], $value)
				)) {
					$isset = true;
					break;
				}
			}

		$form->new_element("entry_fields_".$key,array(
			"label"	=> $core->language->translate($value["label"]),
			"type"	=> "checkbox",
			"value"	=> ifttt($isset, [1], []),
			"values" => [1 => $value["label"]],
		));

		if (!isset($value["type"]) || in_array($value["type"],array("text","number")) )
			$form->new_element("entry_fields_".$key."_calc",array(
				"label"	=> "",
				"type"	=> "select",
				"value"	=> ifttt($isset, key_of("calc", key_of($p_key, $properties))),
				"values"	=> $calc_types,
			));

		else{
			$form->new_element("entry_fields_".$key."_calc_hidden",array(
				"type"	=> "hidden",
			));
		}
		$form->new_element("entry_fields_".$key."_format",array(
			"label"	=> "",
			"type"	=> "select",
			"value"	=> array(($isset && isset($properties[$p_key]["format"]) ? $properties[$p_key]["format"] : ((isset($value["type"]) && $value["type"] == "file") ? "file" : "")),$format_types),
		));

		$current_option_types = $option_types;

		if(!isset($value["type"]) || !in_array($value["type"],array("foreign","correlation","group_ID")))
			unset($current_option_types["filter"]);

		if (are_equal("correlation", key_of("type", $value)))
			$current_option_types["use_intersect"] = "Intersect values";

		$form->new_element("entry_fields_".$key."_option",array(
				"label"	=> "",
				"type"	=> "checkbox",
				// "value"	=> array(($isset && isset($properties[$p_key]["option"]) ? $properties[$p_key]["option"] : array("")),$current_option_types),
				// "value"	=> key_of("option", $properties[$p_key]),
				"value"	=> ifttt($isset, key_of("option", key_of($p_key, $properties))),
				"values"	=> $current_option_types,

		));

		if($isset)
		unset($properties[$p_key]);
	}

	$form1_count = count($form->element);

}

// General Data Fields

$general[] = array(
	"key"	=>"ID",
	"label"	=> "ID",
);

if($object->position)
$general[] = array(
	"key"	=>"position",
	"label"	=> "Position",
);

if($object->statistic){
	$general[] = array(
		"key"	=>"created",
		"label"	=> "Erstellt am",
		"format"	=> "datetime",
	);
	$general[] = array(
		"key"	=>"updated",
		"label"	=> "Geändert am",
		"format"	=> "datetime",
	);
}

foreach($general as $key => $value){

	$isset = false;

	if(not_empty($properties))
		foreach ($properties as $p_key => $p_value) {
			if(
				$p_value["label"] == $value["label"] &&
				$p_value["key"] == $value["key"]
			){
				$isset = true;
				break;
			}
		}

	$form->new_element("general_".$key,array(
		"label"	=> "",
		"type"	=> "checkbox",
		"value"	=> $isset ? array(array(1),array(1=>$value["label"])) : array(array(),array(1=>$value["label"])),
	));

	if($isset)
	unset($properties[$p_key]);

}

$form3_count = count($form->element) - $form1_count;


// New Data Output Fields

$form->new_element('content',array(
		"label"	=> "",
		"array"	=> true,
		"value"	=> key_fetch("value",$properties),
));

$form->new_element('key',array(
		"label"	=> "",
		"value"	=> key_fetch("key",$properties),
		"array"	=> true,
));

$form->new_element('label',array(
		"label"	=> "",
		"value"	=> key_fetch("label",$properties),
		"array"	=> true,
));

$form->new_element('calc',array(
		"label" => "",
		"type" => "select",
		"values" => $calc_types,
		"value" => key_fetch("calc",$properties),
		"array" => true,
));

$form->new_element('format',array(
		"label"	=> "",
		"type"	=> "select",
		"values"	=> $format_types,
		"value"	=> key_fetch("format",$properties),
		"array"	=> true,
));


$table1 = $core->view->table();
$table1->config("sort", false);

$table1->new_element("check",array(
	"title"	=> "Use",
));

$table1->new_element("calc",array(
	"title"	=> "Calculations",
));
$table1->new_element("format",array(
	"title"	=> "Format",
));
$table1->new_element("option",array(
	"title"	=> "Options",
));

$table2 = $core->view->table();
$table2->config("sort", false);

$table2->new_element("value",array(
	"title"	=> "Label",
));
$table2->new_element("key",array(
	"title"	=> "Key",
));
$table2->new_element("content",array(
	"title"	=> "Database key name (optional)",
));
$table2->new_element("calc",array(
	"title"	=> "Calculations",
));
$table2->new_element("format",array(
	"title"	=> "Format",
));


$table3 = $core->view->table();
$table3->config("sort", false);

$table3->new_element("check",array(
	"title"	=> "Use",
));


$form2_count = count($form->element) - $form1_count - $form3_count;

$form->new_element('save',array(
	'value'		=> 'Save',
	'type'		=> "submit",
	'class'	=> "green",
));


if ($form->submit()) {

	$properties = array();

	// Data Input Fields

	for ($i = 0; $i < count($entry_fields); $i++) {

		$array = false;

		if (not_empty($form->value("entry_fields_".$i))) {

			$array = array(
				"label"	=> $entry_fields[$i]["label"],
				"key"	=> $entry_fields[$i]["key"],
				"type"	=> $entry_fields[$i]["type"],
			);

			if(!empty($entry_fields[$i]["values"]))
				$array["values"] = $entry_fields[$i]["values"];

			if(!empty($entry_fields[$i]["filter"]))
				$array["filter"] = $entry_fields[$i]["filter"];

			if(!empty($entry_fields[$i]["options"]))
				$array["options"] = $entry_fields[$i]["options"];

			$array["calc"] = $form->value("entry_fields_".$i."_calc");
			$array["format"] = $form->value("entry_fields_".$i."_format");
			$array["option"] = $form->value("entry_fields_".$i."_option");

		}

		if ($array)
			$properties[] = $array;
	}

	// New Data Output Fields

	$key = $form->value("key");
	$content = $form->value("content");
	$label = $form->value("label");
	$calc = $form->value("calc");
	$format = $form->value("format");

	$count = array(count($key), count($content), count($label), count($calc), count($format));
	$count = current($core->array->sort($count));

	for ($i = 0; $i < $count; $i++) {

		if (are_empty(
			key_of($i, $form->value("key")),
			key_of($i, $form->value("content"))
			))
			continue;

		$properties[] = array(
			"value"	=> either(key_of($i, $form->value("content")), ""),
			"key"	=> either(key_of($i, $form->value("key")), ""),
			"label"	=> either(key_of($i, $form->value("label")), ""),
			"calc"	=> either(key_of($i, $form->value("calc")), ""),
			"format"	=> either(key_of($i, $form->value("format")), ""),
		);


	}

	// General Data Fields
	for ($i = 0; $i < count($general); $i++) {

		$array = false;

		if (!empty($form->value("general_".$i))) {

			$array = array(
				"label"	=> $general[$i]["label"],
				"key"	=> $general[$i]["key"],
			);

			if (!empty($general[$i]["format"]))
				$array["format"] = $general[$i]["format"];
		}

		if($array)
			$properties[] = $array;
	}

	$set_config("overview_properties",$properties);

	$core->refresh();
}

$forms = $form->render_as_array();

$form1 = array_slice($forms, 0, $form1_count);
$form3 = array_slice($forms, $form1_count,$form3_count);
$form2 = array_slice($forms, $form1_count+$form3_count,$form2_count);

foreach ($form1 as $key => $entry) {

	if ($key%4==0) {
		$form1[$key]["check"] = $form1[$key]["field"];
		$form1[$key]["calc"] = $form1[$key+1]["field"];
		$form1[$key]["format"] = $form1[$key+2]["field"];
		$form1[$key]["option"] = $form1[$key+3]["field"];
		unset($form1[$key+1]);
		unset($form1[$key+2]);
		unset($form1[$key+3]);
	}
}


foreach($form3 as $key => $entry){
	$form3[$key]["check"] 	= $form3[$key]["field"];
	unset($form3[$key]["label"]);
	unset($form3[$key]["field"]);
}

foreach($form2 as $key => $entry) {

	if ($key%5 == 0) {
		$form2[$key]["content"] = $form2[$key]["field"];
		$form2[$key]["key"] = $form2[$key+1]["field"];
		$form2[$key]["value"] = $form2[$key+2]["field"];
		$form2[$key]["calc"] = $form2[$key+3]["field"];
		$form2[$key]["format"] = $form2[$key+4]["field"];
		unset($form2[$key+1]);
		unset($form2[$key+2]);
		unset($form2[$key+3]);
		unset($form2[$key+4]);
	}
}


$panel = [];

if(!empty($form1))
	$panel[$core->language->translate("Use exisiting Data Input Fields")] = $table1->render($form1);

$panel[$core->language->translate("Add Data Output Fields")] = $table2->render($form2);
$panel[$core->language->translate("General Data Fields")] = $table3->render($form3);

$footer = [
	$form->field("save"),
	$core->template->kit->button("Close", ["href"=>$core->url(array("do"=>""))])
];

echo $core->template->kit->panel(
	"Edit Data Output Fields",
	$core->template->kit->tabs($panel),
	$footer,
	array(
		"wrap_form"=>$form,
		"footer" => array("class"=>"fill flex"),
	)
);

