<?php

if (is_empty($ID = $core->get("ID")))
	return;

$layout = $get_config("edit_layout");
$properties = $get_config("edit_properties");

foreach ($properties as $property) {

	if ($core->array->match(key_of("type", $property), array("foreign"))) {

		if (any_empty($table_name = key_of(0, key_of("values",$property)), $column_name = key_of(1, key_of("values",$property))))
			continue;

		$object->foreign(array(
			key_of("key", $property) => $table_name
		));
	}
}

$entry = $object->entry($ID);

$table = function ($entry = [], $properties = []) use ($core) {

	if (any_empty($entry, is_array($entry), $properties, is_array($properties)))
		return "";

	$cells = [];

	foreach ($properties as $property) {

		if (is_empty($key = key_of("key", $property)))
			continue;

		$label = either(key_of("label", $property), $key);
		$value = key_of($key, $entry);
		$values = key_of("values", $property);
		$type = key_of("type", $property);
		$format = key_of("format", $property);

		if ($core->array->match($type, array("foreign")))
			$value = key_of(key_of(1,$values), $value);

		else if (not_empty($values))
			$value = key_of($value, $values);

		if (not_empty($format))
			$value = $core->format->$format($value);

		// if (are_equal($format, "file") && not_empty($value))
			// $value = $core->template->kit->button("download","",["href"=>key_of($key, $entry),"download"=>true,"class"=>"icon button"]).$value;

		else if (are_equal($type, "markdown") && not_empty($value))
			$value = $core->markdown->decode($value);


		$cells[] = [
			$label,
			$value
		];

	}

	return $core->html->table($cells, false, ["class"=>"data"]);
};


if (not_empty($layout)) {

	$tabs = [];

	foreach ($layout as $label => $fields) {
		$tabs[$label] = $table($entry, keys_of(key_fetch("fields",$fields), $properties));
	}

	$output = $core->template->kit->tabs($tabs);

}

else {

	$output = $table($entry,$properties);

}


$core->template->kit->panel->title($core->language->translate("View"));

$core->template->kit->panel->footer(
	$core->template->kit->button("Close",array("class"=>"cancel button","href"=>$core->url(["do"=>""])))
);

$core->template->kit->panel->body($output);

echo $core->template->kit->panel();