<?php

include("frontend/output.php");

$parse_var = function ($parse = [], $vars = []) {

	if (any_empty($parse, $vars, is_array($vars)))
		return $parse;

	foreach ($vars as $var => $value) {

		if (is_string($parse)) {
			$parse = preg_replace('/\$(filter|entry)_select->'.$var."/",$value, $parse);
			continue;
		}

		if (is_array($parse)) {
			foreach ($parse as $key => $parse_value) {
				$parse[$key] = preg_replace('/\$(filter|entry)_select->'.$var."/",$value, $parse_value);
			}
			continue;
		}
		continue;
	}

	return $parse;

};

$parse_function = function ($string) use (&$parse_function, $core, $get_path, $get_var, $get_switch) {

	if (is_array($string)) {

    foreach($string as $key => $value)
      $string[$key] = $parse_function($value);

    return $string;
  }


  // $function = '/(\$(\w+->)+)?(\w+)\((.*)\)+/s';
  // $function = '/(([\w->$]+)\(((?1)|[^()]+)\))/s';
  $function = '/((\$?[\w\->]+)\(((([\s\r\n:{},=$\w]*)(?1)([\s\r\n:{},=$\w]*))*|[^()]+)\))/s';

  if (preg_match("/confirm\(/",$string))
    return stripslashes($string);

  if (preg_match_all($function,$string,$matches)) {

    $matches = preg_replace_all_reverse($matches);

    foreach ($matches as $match) {

      $replace = $match[0];
      $object = false;
      $func = $match[2];
      $var = $match[3];

			$var = $parse_function($var);

			if (matches("$", $func)) {
				$object = preg_replace("/([$])([\w\->]+)(->\w+)/","$2",$func);
				$func = preg_replace("/([$][\w\->]+)(->)(\w+)/","$3",$func);
			}

			if (matches("->", $object)) {
				$parts = explode("->",$object);
				$object = ${array_shift($parts)};
				foreach ($parts as $part) {
					$object = $object->$part;
				}
			}

    	if($object && method_exists($object,$func)) {
        $string = preg_replace(preg_mod(preg_quote($replace))."",call_user_func_array(array($object,$func),explode(",",$var)),$string);
			}

  		else if(!$object && function_exists($func))
      	$string = preg_replace(preg_mod(preg_quote($replace))."s",call_user_func_array($func,explode(",",$var)),$string);

			else if (in_array($func,["get_path", "get_var", "get_switch"]))
				$string = preg_replace(preg_mod(preg_quote($replace))."s",call_user_func_array($$func,explode(",",$var)),$string);

    }
  }
  return $string;

};

include("frontend/data.php");

if (!empty($kit["kit_option"]["output"]))

  switch ($kit["kit_option"]["output"]) {

    case "table":
      include("frontend/table.php");
      break;

    case "json":
      echo $core->file->read_php($kit["path"]."frontend/json.php",["array"=>$array,"data"=>$data]);
      break;

    case "text":
      include("frontend/text.php");
      break;

    case "link":
      include("frontend/link.php");
      break;

    case "markdown":
      include("frontend/markdown.php");
      break;

    case "function":
      include("frontend/function.php");
      break;

    case "file":
      include("frontend/file.php");
      break;

    case "mixed":
      include("frontend/mixed.php");
      break;

  }
