<?php

$url = "http://kitbooth.com/pages/kit-store-private_kits.html?username=".$core->user->data("name")."&password=".$core->get("kitstore")."&framework=".$core->version("framework")."&core=".$core->version("compatibility");
// $url = "//kitbooth.com/pages/kit-store-private_kits.html?username=".$core->user->data("name")."&password=".$core->get("kitstore")."&framework=".$core->version("framework")."&core=".$core->version("compatibility");
$private_kits = $core->file->read($url);
$private_kits = $core->json->decode($private_kits);

if (!is_array($private_kits))
	$private_kits = false;


$list_kits_to_push = function ($kits) use($core) {

	$url = "http://kitbooth.com/pages/kit-store-users.html?username=".$core->user->data("name")."&password=".$core->get("kitstore");
	$user = $core->file->read($url);
	$user = $core->json->decode($user);

	if(any_empty($user, is_array($user)))
		return false;

	$kits = $core->array->filter_by($kits,"unique_name","^".$user["group_ID"]["name"]."_(.*)");

	return $kits;
};

$data = $core->data("kb_kit");

$kits_to_push = $list_kits_to_push($data->read());

ob_start();

switch ($core->get_var("view")){

	case "store":

		include("functions.php");
		include("store.php");
		break;

	case "updates":

		include("functions.php");
		include("updates.php");
		break;

	case "publish":
		include("functions.php");
		include("publish_list.php");
		break;

	case "private":

		include("functions.php");
		include("store_private_kits.php");
		break;

	case "groups":

		if($core->user->is_dev()){
			include("functions.php");
			include("groups.php");
		}
		break;

	case "create":

		if($core->user->is_dev()){
			include("functions.php");
			include("create.php");
		}
		break;

	default:
		include("functions.php");
		include("local.php");

}

$content = ob_get_clean();
ob_start();

switch ($core->get_var("do")) {

	case "edit":
    if($core->get_var("view") == "groups")
		  include("edit_group.php");
    else
		  include("edit.php");
		break;

	case "kitinfo":

		include("kitinfo.php");
		break;

	case "download":
		include("download.php");
		// include("install.php");
		break;

	case "install":
		include("install.php");
		break;

	case "reload":
		include("reload.php");
		break;

	case "publish":

		include("publish.php");
		break;

	case "deinstall":
		if($ID = $core->get_var("ID")){
			$core->message->set($core->kit->data->delete($ID));
			$core->set_url_options(array("do"=>""));
			$core->refresh = true;
			$core->message->info();

		}
		break;

	case "delete_db":
		if($ID = $core->get_var("ID")){
			$temp_data = $core->kit->load($ID,"data");

			if(!empty($temp_data->db_name))
				$core->message->set($temp_data->delete_tables());

			$core->message->info();
			$core->set_url_options(array("do"=>"","ID"=>""));
			$core->refresh = true;
		}
		break;

	case "delete_fs":
		if ($folder = $core->get_var("folder")) {
			$core->filesystem->set_base_dir(KITS_FOLDER);
			$core->message->set($core->filesystem->delete_folder($folder));
			$core->message->info();
			$core->set_url_options(array("do"=>"","folder"=>""));
			$core->refresh(true);
		}
		break;

}
$action = ob_get_clean();

$menu = array();

if($core->user->is_dev())
	$menu = array(
		"" => array(
			"title" => "Kits",
			"class" => "small"
		),
		"groups" => array(
			"title" => "Menu",
			"class" => "small"
		),
		"store" => array(
			"title" => "Store",
			"class" => "small"
		),
		"updates" => array(
			"title" => "Updates",
			"class" => "small"
		),


	);

if($private_kits)
	$menu["private"] = array(
		"title" => "Private Kits",
		"class" => "small"
	);

if($kits_to_push)
	$menu["publish"] = array(
		"title" => "Publish",
		"class" => "small"
	);

if($core->user->is_dev())
	$menu["create"] = array(
		"title" => "Create",
		"class" => "small"
	);

$menu = $core->template->kit->menu($menu);
$menu = $core->html->div($menu);


echo $core->template->kit->content(
	$menu,
	$content
);

echo $action;