<?php

if ($core->version("release") == "{#{SVN}#}" || $core->version("channel") == "{#{KBRT}#}"){

	$core->message->set(false, "SVN-Revision or Release-Type ERROR - you can't autoupdate a svn-checkout!");
	$core->message->info('', "SVN-Revision or Release-Type ERROR - you can't autoupdate a svn-checkout!");
}

if (!function_exists('curl_init')) {

	$core->message->set(false, "The PHP Curl extension is needed by autoupdate!");
	$core->message->info("", "The PHP Curl extension is needed by autoupdate!");
}


$date = date("YmdHis");
$name = "kitbooth_core_v".$core->version()."_".$date;

$kitbooth = $core->filesystem();
$kitbooth->dir($core->path());
$kitbooth->folder->create("backup/".$name);

$backup = $core->filesystem();
$backup->dir($core->path()."backup");

$db_prefix = key_of("prefix", $core->core_config("db"));

$cleanup = function() use ($core, $name, $kitbooth, $backup) {

	$kitbooth->folder->delete('.update_temp');
	$kitbooth->file->delete('kb-update.tmp.zip');
	$backup->folder->delete($name);

};

if ($core->message->status()) {

	$url="http://svn.kitbooth.com/builds/kitbooth-".$core->version("channel").".txt";
	$ver_arr = explode("\n",trim($kitbooth->get_remote_file($url)));

	$url="http://svn.kitbooth.com/builds/".$core->version("channel")."_log.php?from=".$core->version("release");
	$changelog = $kitbooth->get_remote_file($url);

	if (empty($changelog)){

		$changelog = array();

	}

	else {

		$changelog = preg_replace("/[$]/","&dollar;",$changelog);
		$changelog = $core->json->decode($changelog);

		foreach ($changelog as $key => $log) {

			$log = $core->markdown->decode($log);
			$log = $core->html->parse($log);
			$category = "Changelog";
			$columns = [];

			foreach($log as $index => $entry) {

				if (is_array($entry) && key($entry) == "h1"){
					$category = trim($entry["h1"][0]);
					$log[$category] = "";
					$columns[$category] = "";
				}

				else {
					$log[$category] = key_of($category,$log).$core->html->render($entry);
				}
				unset($log[$index]);
			}

			$changelog[] = array_merge(
				array(
					"Revision"	=> $key
				),$log
			);

			unset($changelog[$key]);
		}
	}

	foreach($changelog as $key => $log)
		$changelog[$key] = array_merge($columns, $log);

	$url="http://svn.kitbooth.com/builds/".$core->version("channel")."_diff.php?from=".$core->version("release");
	$changelog_db = trim($kitbooth->get_remote_file($url));
	$changelog_db = preg_replace("-\n-","<br>",$changelog_db);

	switch ($core->get("do")) {

		case "update":

			if ($core->message->status()) {

				$url="http://svn.kitbooth.com/builds/kitbooth-".$core->version("channel").".txt";
				$ver_arr = explode("\n",trim($kitbooth->get_remote_file($url)));
				$core->message->set( (count($ver_arr) < 2 ) ? false:true , "UPDATE: test version file empty");
				$core->message->set( ( (int) $core->version("release") > 0 ) && ( $core->version("release") > $ver_arr[0] ) ? false:true , "UPDATE: revision verification ".$core->version("release")." < ".$ver_arr[0]);

			}

			if ($core->message->status()) {

				$url="http://svn.kitbooth.com/builds/".$core->version("channel")."_diff.php?from=".$core->version("release");
				$sql_change = trim($core->filesystem->get_remote_file($url));
					if($db_prefix != "" ) {


						$pattern[] = "/[^_]kb_/";
						$replacement[] = ' '.$db_prefix.'kb_';
						$sql_change = preg_replace($pattern, $replacement, $sql_change);
					}
				$core->message->set(!empty($sql_change), "UPDATE: SQL FILE test if empty");
			}

			if ($core->message->status()) {

				$kitbooth->folder->create(".update_temp");
				$kitbooth->file->delete('.update_temp/kb-update.tmp.zip');
				$url = "http://svn.kitbooth.com/builds/kitbooth-".$core->version("channel").".zip";
				$zip = $kitbooth->get_remote_file($url, '.update_temp/kb-update.tmp.zip');
				$md5 = md5($zip);

			}

			if ($core->message->status()) {

				$url="http://svn.kitbooth.com/builds/kitbooth-".$core->version("channel").".zip.md5";
				$md5_txt = trim($core->filesystem->get_remote_file($url));

			}

			if ($core->message->status() && $md5 == $md5_txt) {

				$kitbooth->file->unzip('.update_temp/kb-update.tmp.zip', '.update_temp');

				if ($kitbooth->folder->exists('.update_temp/core')) {

					$core->message->set(
						$backup->file->write(
							"$name/kitbooth.sql",
							$core->db->dump()
						),
						"mysql dump"
					);

					$core_sql = explode(";", $sql_change);

					if ($core->message->status() && $core->db->start_transaction() && count($core_sql) > 1) {

            $core->config("sql_version",(int)$ver_arr[0]);

						$core->db->query("SET FOREIGN_KEY_CHECKS=0");

						foreach ($core_sql AS $sql) {
							$sql = trim($sql);

							if(!empty($sql)) {
								$stm = $core->db->sql_query($sql, "UPDATE: sql diff - ".$sql);
							}
						}
					}

					$core->db->query("SET FOREIGN_KEY_CHECKS=1");

					//($core->message->status()) ? $core->db->sql_query($sql_change, "UPDATE: sql diff") : true;

					$kitbooth->folder->move("core", "backup/".$name."/");

					if (!$kitbooth->folder->move(".update_temp/core", ""))
						$kitbooth->folder->move("backup/".$name."/core", "");

					$kitbooth->folder->move("kits/kb_standard", "backup/".$name."/kits");

					if (!$kitbooth->folder->move(".update_temp/kits/kb_standard", "kits"))
						$kitbooth->folder->move("backup/".$name."/kits/kb_standard", "kits");

					$kitbooth->file->move(".htaccess", "backup/".$name."/");

					if (!$kitbooth->file->move(".update_temp/.htaccess", ""))
						$kitbooth->file->move("backup/".$name."/.htaccess", "");

					$backup->folder->zip($name);

					if ($core->message->status()) {
						$kitbooth->folder->move(".update_temp/upgrade", "");
						$backup->folder->delete($name);
						$core->db->end_transaction();
					}

					else {

						$core->db->set_rollback();

						$kitbooth->folder->copy("backup/$name/core", "", ["merge"=>false]);
						$kitbooth->folder->copy("backup/$name/kits/kb_standard", "kits", ["merge"=>false]);
						$kitbooth->file->copy("backup/$name/.htaccess", "");

					}

					$cleanup();

					if ($core->message->status()) {

						$core->upgrade();
						$core->message->info("Kitbooth update was successful","There was an error updating Kitbooth");
						$core->refresh(["do"=>"","view"=>""]);

					}
				}


			}

			else {


				$core->message->set(false, 'KIT-UPDATE: MD5 Failure - '.$md5." - ".$md5_txt);
			}

		break;

		default:
			$cleanup();
			break;
	}
}



$menu = array(
	"" => array(
		"title" => "Release",
	)
);

if (not_empty($changelog))
	$menu["changelog"] = array(
		"title" => "Changelog",
	);

$menu = $core->template->kit->menu($menu);

?>
<div class="kitcontent">
	<div class="section">
		<?=$core->html->render($menu)?>
	</div>
	<div class="section">

	<?php

		if($core->message->status() && $core->message->set( (count($ver_arr) < 2 ) ? false:true , "Version file empty")) {

		if($core->get_var("view") == "") {

			echo $core->html->render($core->html->table(
				[[
					$core->html->h2($core->version("compatibility").".".$core->version("framework").".".$core->version("release")),
					$core->html->h2($core->version("channel")),
					$core->html->h2($ver_arr[3].".".$ver_arr[2].".".$ver_arr[0],["title"=>"Release: ".$ver_arr[1]]),
				]],
				[
					"Installed version",
					"Release Channel",
					"Available version"
				],
				[
					"class" => "form"
				]
			));

		}

		if(((int)$core->version("release") > 0) && $core->version("release") < $ver_arr[0] && $core->get_var("view") == "changelog"){	?>
			<?=$core->html->render($core->html->table($changelog,array_keys(current($changelog)),array("class"=>"data wrap changelog")))?>
		<?php } ?>
		</div>
		<?php
		if(((int)$core->version("release") > 0) && $core->version("release") < $ver_arr[0] ){
		?>
			<div class="section">
				<a class="green button" href="<?=$core->url(array('do'=>'update'))?>">Update</a>
			</div>
		<?php }
	}
	else {

?>

		<hr>
		<p>An error occurred.</p>
	<?php
	}
	?>

</div>