<?php

$html_entities = function ($input = "") {

	if (is_empty($input))
		return $input;

	if (!is_string($input))
		return $input;

	$output = preg_replace(
		array(
			"/\(/",
			"/\)/",
			// "/\?/",
		),
		array(
			"&#40;",
			"&#41;",
			// "%3F",
		),
		$input
	);

	return $output;

};


$return_function = function ($entry,$column,$function) use ($core) {

	// Backwards Compatibility
		$format = $core->format;

	if (!is_array($function) || is_indexed($function))
		return "";

  $func_args = current($function);
  $func_name = key($function);

  if (preg_match("/core->/",$func_name))
    $func_name = array(
      0 => $core->{preg_replace("/^(core->)(.*)(->[^>]+)$/","$2",$func_name)},
      1 => preg_replace("/.+->([^>]+)$/","$1",$func_name),
    );

  else if (preg_match("/->/",$func_name))
    $func_name = array(
      0 => ${preg_replace("/->.+/","",$func_name)},
      1 => preg_replace("/.+->/","",$func_name),
    );

  foreach ($func_args as &$arg) {

		if (is_string($column)) {


		  if (are_equal($arg, $column))
        $arg = key_of($column, $entry);

			else if (matches("$".$column,$arg))
				$arg = preg_replace("/[$]$column/",key_of($column, $entry),$arg);

		}

		else if (is_array($column)) {

			if ($arg == current($column)) {
				$arg = fetch(key($column), $entry);
				$arg = $core->json->decode($arg);
				$arg = key_of(current($column), $arg);
			}

			else if ($arg == key($column)) {
				$arg = fetch(key($column), $entry);
				$arg = $core->json->decode($arg);
			}

			else if (preg_match(preg_mod("$".key($column),false),$arg)) {

				$arg = preg_replace(
					preg_mod("$".key($column),false),
					$core->json->decode(
						fetch(key($column),
						$entry
						)
					),
					$arg
				);
			}

			else if (preg_match(preg_mod("$".current($column),false),$arg)) {

				$arg = preg_replace(
					preg_mod("$".current($column),false),
					key_of(
						current($column),
						$core->json->decode(
							fetch(key($column),
							$entry
							)
						)
					),
					$arg
				);
			}
		}

  }

  return call_user_func_array($func_name,$func_args);

};


$return_markdown = function ($entry, $column, $options = []) use ($core) {

	if (is_array($column)) {
    $sub_entry = key_fetch(key($column),$entry);
    $sub_entry = $core->json->decode($sub_entry);
    return $core->markdown->decode(key_fetch(current($column),$sub_entry),$options);
  }
  else {
    return $core->markdown->decode(key_fetch($column, $entry),$options);
  }
};


$return_file = function ($entry, $column, $options = []) use ($core) {

  if (is_array($column)) {
    $sub_entry = fetch(key($column),$entry);
    $sub_entry = $core->json->decode($sub_entry);
    $files = fetch(current($column),$sub_entry);
    $files = $core->json->decode($files);
  }
  else {
    $files = $entry[$column];
    $files = $core->json->decode($files);
  }

  if (is_empty($files))
  	return false;

  if (!is_indexed($files))
    $files = array($files);

	if ($limit = fetch("limit", $options))
		$files = array_slice($files, 0, $limit);

  return $core->format->file(
    $files,
    array(
      "render_filetypes"=>true,
      "class" => key_of("class",$options),
      "title" => key_of("title",$options),
      "thumbnail" => key_of("thumbnail",$options),
      "size" => key_of("size",$options),
      "video" => key_of("video",$options),
      "raster" => key_of("raster",$options),
      )
    );

};


$return_text = function ($entry = [],$column = "",$options = []) use ($core, &$return_text, $html_entities) {

  if (is_array($column)) {

    $entry = key_fetch(key($column),$entry);
    $entry = $core->json->decode($entry);
		$column = current($column);
		return $return_text($entry, $column, $options);
  }
  // return key_fetch($column, $entry);
  // return preg_replace(array("/\(/","/\)/"), array("&#40;","&#41;"), key_fetch($column, $entry));
  return $html_entities(key_fetch($column, $entry));
};


$return_link = function ($entry, $column, $options) use ($core) {

	if (is_array($column)) {
    $sub_entry = fetch(key($column),$entry);
    $sub_entry = $core->json->decode($sub_entry);
    return $core->format->website(fetch(current($column),$sub_entry));
  }
  else {
    return $core->format->website(fetch($column, $entry));
  }
};


$get_var = function ($args) use ($core) {

  $args = preg_split("-,-",$args);
  $var = $args[0];
  $default = isset($args[1]) ? $args[1] : "";

  return $core->get_var($var) ?: $default;

};


$get_path = function ($offset = 0, $else = "") use ($core) {

	$offset = intval($offset);
	$paths = explode("/",$core->get("lid"));
	$path = (array) array_slice($paths,$offset,1);

	if (is_empty($path))
		return $else;

	$path = current($path);
	return html_entity_decode($path);
};


$get_switch = function ($get_var = "", $compare_var = "", $true_value = "", $false_value = "") use ($core) {

  $get_var_default = false;

  if (preg_match("-|-",$get_var)) {
    $get_var_split = preg_split("-\|-",$get_var);
    $get_var = array_shift($get_var_split);
    $get_var_default = !empty($get_var_split) ? $get_var_split : false;
  }

	if (is_numeric($get_var) && are_equal(get_path($get_var),$compare_var))
		return $true_value;

  if ($core->get_var($get_var) == false && $get_var_default === false)
    return $false_value;

  if ($core->get_var($get_var) == $compare_var)
    return $true_value;

  if ($core->get_var($get_var) == false && $get_var_default && in_array($compare_var,$get_var_default))
    return $true_value;

  return $false_value;

};


